#include<iostream>
#include<algorithm>
#include <vector>
#include <set>
#include <queue>
using namespace std;

typedef long long ll;

vector<vector<pair<int, int>>>g;
vector<vector<bool>>ban;

vector<int> dei(int s, vector<ll>& d) {
	d[s] = 0;
	set<pair<int, int>>q;
	q.insert({ 0, s });
	vector<int>p;
	while (!q.empty()) {
		int v = q.begin()->second;
		p.push_back(v);
		q.erase(q.begin());
		for (auto u : g[v]) {
			if (d[u.first] > d[v] + u.second) {
				q.erase({ d[u.first], u.first });
				d[u.first] = d[v] + u.second;
				q.insert({ d[u.first], u.first });
			}
		}
	}
	return p;
}
ll mod = 1e9 + 7;
vector<ll> get_cnt(int n, int s, vector<int>& p, vector<ll>& d, bool is_ban) {
	vector<ll>cnt(n, 0);
	cnt[s] = 1;
	for (auto v : p) {
		for (int i = 0; i < g[v].size(); i++) {
			if (cnt[g[v][i].first] != 0 && g[v][i].second + d[g[v][i].first] == d[v]) {
				cnt[v] = (cnt[g[v][i].first] + cnt[v]) % mod;
				ban[v][i] = is_ban;
			}
		}
	}
	return cnt;
}

ll inf = 1e18;
ll solve_B(int n, int m, int s, int t, ll L) {
	ban.resize(n);
	for (int i = 0; i < n; i++) {
		ban[i].resize(g[i].size());
	}
	vector<ll>ds(n, inf), dt(n, inf);
	vector<int>ps = dei(s, ds);
	vector<int>pt = dei(t, dt);
	vector<ll>cnts = get_cnt(n, s, ps, ds, false), cntt = get_cnt(n, t, pt, dt, true);
	ll ans = 0;
	if (dt[s] == L)
		ans = cntt[s];
	for (int v = 0; v < n; v++) {
		if (ds[v] + dt[v] == ds[t]) {
			for (int i = 0; i < g[v].size(); i++) {
				if (ban[v][i])
					continue;
				if (ds[v] + g[v][i].second + dt[g[v][i].first] == L)
					ans = (ans + cnts[v] * cntt[g[v][i].first] % mod) % mod;
			}
		}
	}
	return ans;
}

int main() {
	int n, m, s, t;
	ll L;
	cin >> n >> m >> s >> t >> L;
	s--, t--;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int v, u, c;
		cin >> v >> u >> c;
		v--, u--;
		g[v].push_back({ u, c });
		g[u].push_back({ v, c });
	}
	cout << solve_B(n, m, s, t, L);
	return 0;
}