#include<iostream>
#include<algorithm>
#include <vector>
#include <set>
#include <queue>
using namespace std;

typedef long long ll;

vector<vector<pair<int, ll>>>g;
vector<vector<bool>>ban;

ll mod = 1e9 + 7;

void dei(int s, vector<ll>& d, vector<ll>& cnt) {
	d[s] = 0;
	cnt[s] = 1;
	set<pair<ll, int>>q;
	q.insert({ 0, s });
	while (!q.empty()) {
		int v = q.begin()->second;
		q.erase(q.begin());
		for (auto u : g[v]) {
			if (d[u.first] > d[v] + u.second) {
				q.erase({ d[u.first], u.first });
				d[u.first] = d[v] + u.second;
				q.insert({ d[u.first], u.first });
				cnt[u.first] = cnt[v];
			}
			else if (d[u.first] == d[v] + u.second) {
				cnt[u.first] = (cnt[u.first] + cnt[v]) % mod;
			}
		}
	}
}

ll inf = 1e17;
ll solve_B(int n, int m, int s, int t, ll L) {
	ban.resize(n);
	for (int i = 0; i < n; i++) {
		ban[i].resize(g[i].size());
	}
	vector<ll>ds(n, inf), dt(n, inf);
	vector<ll>cnts(n, 0), cntt(n, 0);
	dei(s, ds, cnts);
	dei(t, dt, cntt);
	for (int v = 0; v < n; v++) {
		for (int i = 0; i < g[v].size(); i++) {
			if (ds[v] + g[v][i].second + dt[g[v][i].first] == dt[s]) {
				ban[v][i] = true;
			}
		}
	}
	ll ans = 0;
	if (dt[s] == L)
		ans = cntt[s];
	for (int v = 0; v < n; v++) {
		if (ds[v] + dt[v] == ds[t]) {
			for (int i = 0; i < g[v].size(); i++) {
				if (ban[v][i])
					continue;
				if (ds[v] + g[v][i].second + dt[g[v][i].first] == L)
					ans = (ans + cnts[v] * cntt[g[v][i].first] % mod) % mod;
			}
		}
	}
	return ans;
}

int main() {
	int n, m, s, t;
	ll L;
	cin >> n >> m >> s >> t >> L;
	s--, t--;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int v, u, c;
		cin >> v >> u >> c;
		v--, u--;
		g[v].push_back({ u, c });
		g[u].push_back({ v, c });
	}
	cout << solve_B(n, m, s, t, L);
	return 0;
}