#include <bits/stdc++.h>

using namespace std;

//#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef __int128 int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
const int INF = 1e9 + 7;

#define int ll

//mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const int inf = 1e18;

struct Tree {
    vector<int> tree, push;
    int s;

    Tree(int n) {
        s = 1;
        while (s < n) {
            s *= 2;
        }
        tree.assign(2 * s + 1, inf);
        push.resize(2 * s + 1);
    }

    void prop(int x, int lx, int rx) {
        if (lx + 1 == rx || push[x] == 0) {
            return;
        }
        int p = push[x];
        tree[2 * x + 1] += p;
        tree[2 * x + 2] += p;
        push[2 * x + 1] += p;
        push[2 * x + 2] += p;
        push[x] = 0;
    }

    void set(int i, int v, int x, int lx, int rx) {
        if (lx + 1 == rx) {
            tree[x] = v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            set(i, v, 2 * x + 1, lx, m);
        } else {
            set(i, v, 2 * x + 2, m, rx);
        }
        tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
    }

    void add(int l, int r, int v, int x, int lx, int rx) {
        if (lx >= r || rx <= l) {
            return;
        }
        prop(x, lx, rx);
        if (lx >= l && rx <= r) {
            tree[x] += v;
            return;
        }
        int m = (lx + rx) / 2;
        add(l, r, v, 2 * x + 1, lx, m);
        add(l, r, v, 2 * x + 2, m, rx);
        tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
    }

    int get(int l, int r, int x, int lx, int rx) {
        if (lx >= r || rx <= l) {
            return inf;
        }
        prop(x, lx, rx);
        if (lx >= l && rx <= r) {
            return tree[x];
        }
        int m = (lx + rx) / 2;
        return min(get(l, r, 2 * x + 1, lx, m), get(l, r, 2 * x + 2, m, rx));
    }
};

void solve() {
    int n, b, c;
    cin >> n >> b >> c;
    vector<int> x(n), p(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i];
    }
    Tree st(n);
    for (int i = 0; i < n; i++) {
        st.set(i, c, 0, 0, st.s);
    }
    set<pair<int, int>> setik;
    setik.insert({p[0], 0});
    for (int i = 1; i < n; i++) {
        int need = x[i] - x[i - 1];
        while (!setik.empty() && need > 0) {
            auto [_, v] = *setik.begin();
            int rv = st.get(v, i, 0, 0, st.s);
            rv = min(rv, b / _);
            if (rv == 0) {
                setik.erase(setik.begin());
                continue;
            }
//            cerr << i << ' ' << v << ' ' << rv << '\n';
            int sub = min(rv, need);
            b -= _ * sub;
            need -= sub;
            st.add(v, i, -sub, 0, 0, st.s);
        }
        if (need != 0) {
            cout << x[i] - need;
            return;
        }
        setik.insert({p[i], i});
    }
//    cerr << 1 << endl;
    int cur = x.back();
    while (!setik.empty()) {
         auto [_, v] = *setik.begin();
        int rv = st.get(v, n, 0, 0, st.s);
        rv = min(rv, b / _);
//        cerr << v << ' ' << rv << '\n';
        if (rv == 0) {
            setik.erase(setik.begin());
            continue;
        }
        b -= _ * rv;
        cur += rv;
        st.add(v, n, -rv, 0, 0, st.s);
    }

    cout << cur << '\n';
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
