#ifdef Local
#include "debug.h"
#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define debug(...)
#endif
#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x.size())
using namespace std;
typedef long double ld;
typedef long long ll;

vector<pair<int, int>> g[200500];
pair<int, int> from_s[200500];
pair<int, int> to_t[200500];

const int mod = 1'000'000'007;

void solve() {
    int n, m;
    cin >> n >> m;
    int s, t, L;
    cin >> s >> t >> L;
    vector<tuple<int, int, int>> edges;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
        edges.emplace_back(u, v, w);
        edges.emplace_back(v, u, w);
    }
    {
        vector<int> dist(n + 1, INT32_MAX);
        dist[s] = 0;
        set<pair<int, int>> Q;
        Q.insert({dist[s], s});
        while (!Q.empty()) {
            int u = Q.begin()->second;
            Q.erase(Q.begin());
            for (auto [v, w] : g[u]) {
                if (dist[v] > dist[u] + w) {
                    Q.erase({dist[v], v});
                    dist[v] = dist[u] + w;
                    Q.insert({dist[v], v});
                }
            }
        }
        vector<int> a(n);
        iota(a.begin(), a.end(), 1);
        sort(a.begin(), a.end(), [&dist](int u, int v){
            return dist[u] < dist[v];
        });
        from_s[s].second = 1;
        for (int u = 1; u <= n; u++) {
            from_s[u].first = dist[u];
        }
        for (int u : a) {
            if (dist[u] == INT32_MAX) break;
            for (auto [v, w] : g[u]) {
                if (dist[v] == dist[u] + w) {
                    from_s[v].second += from_s[u].second;
                    from_s[v].second %= mod;
                }
            }
        }
        if (dist[t] == L) {
            cout << from_s[t].second << "\n";
            return;
        }
    }
    {
        vector<int> dist(n + 1, INT32_MAX);
        dist[t] = 0;
        set<pair<int, int>> Q;
        Q.insert({dist[t], t});
        while (!Q.empty()) {
            int u = Q.begin()->second;
            Q.erase(Q.begin());
            for (auto [v, w] : g[u]) {
                if (dist[v] > dist[u] + w) {
                    Q.erase({dist[v], v});
                    dist[v] = dist[u] + w;
                    Q.insert({dist[v], v});
                }
            }
        }
        vector<int> a(n);
        iota(a.begin(), a.end(), 1);
        sort(a.begin(), a.end(), [&dist](int u, int v){
            return dist[u] < dist[v];
        });
        to_t[t].second = 1;
        for (int u = 1; u <= n; u++) {
            to_t[u].first = dist[u];
        }
        for (int u : a) {
            if (dist[u] == INT32_MAX) break;
            for (auto [v, w] : g[u]) {
                if (dist[v] == dist[u] + w) {
                    to_t[v].second += to_t[u].second;
                    to_t[v].second %= mod;
                }
            }
        }
    }
    int ans = 0;
    for (auto [u, v, w] : edges) {
        if (u != t && from_s[u].first + w + to_t[v].first == L) {
            if (from_s[u].first + to_t[u].first == from_s[t].first) {
                ans += from_s[u].second * to_t[v].second;
                ans %= mod;
            }
        }
    }
    cout << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(12);
    int tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}