#include <iostream>
#include <iomanip>
#include <vector>

#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

constexpr ll INF = 1e12;

struct st {
	ll x = 0;
	ll y = 0;

	st(ll x, ll y) :x(x), y(y) {}

	const bool operator==(const st& val) const {
		return x == val.x && y == val.y;
	}

	const bool operator!=(const st& val) const {
		return x != val.x || y != val.y;
	}
};

vector<string> g;
ll n, m;

void dfs1(const st v) {
	g[v.x][v.y] = '!';
	if (g[v.x][v.y - 1] == '.')
		dfs1(st(v.x, v.y - 1));
	if (g[v.x][v.y + 1] == '.')
		dfs1(st(v.x, v.y + 1));
	if (g[v.x - 1][v.y] == '.')
		dfs1(st(v.x - 1, v.y));
	if (g[v.x + 1][v.y] == '.')
		dfs1(st(v.x + 1, v.y));
}

const bool okA(const st v) {
	bool ok = false;
	ok |= (g[v.x][v.y - 1] == '.');
	ok |= (g[v.x][v.y + 1] == '.');
	ok |= (g[v.x - 1][v.y] == '.');
	ok |= (g[v.x + 1][v.y] == '.');
	return ok && (g[v.x][v.y] == 'a' || g[v.x][v.y] == '#');
}

const bool okB(const st v) {
	bool ok = false;
	ok |= (g[v.x][v.y - 1] == 'a');
	ok |= (g[v.x][v.y + 1] == 'a');
	ok |= (g[v.x - 1][v.y] == 'a');
	ok |= (g[v.x + 1][v.y] == 'a');
	return ok && (g[v.x][v.y] == 'b' || g[v.x][v.y] == '#');
}

st beg(-1, -1);

bool dfsB(const st v, const st p);

bool dfsA(const st v, const st p) {
	g[v.x][v.y] = 'c';
	if (g[v.x][v.y - 1] == 'c' && st(v.x, v.y - 1) != p) {
		g[v.x][v.y] = 'y';
		return true;
	}
	if (g[v.x][v.y + 1] == 'c' && st(v.x, v.y + 1) != p) {
		g[v.x][v.y] = 'y';
		return true;
	}
	if (g[v.x - 1][v.y] == 'c' && st(v.x - 1, v.y) != p) {
		g[v.x][v.y] = 'y';
		return true;
	}
	if (g[v.x + 1][v.y] == 'c' && st(v.x + 1, v.y) != p) {
		g[v.x][v.y] = 'y';
		return true;
	}


	if (g[v.x][v.y - 1] == 'a' && st(v.x, v.y - 1) != p) {
		if (dfsA(st(v.x, v.y - 1), v)) {
			g[v.x][v.y] = 'y';
			return true;
		}
	}
	if (g[v.x][v.y + 1] == 'a' && st(v.x, v.y + 1) != p) {
		if (dfsA(st(v.x, v.y + 1), v)) {
			g[v.x][v.y] = 'y';
			return true;
		}
	}
	if (g[v.x - 1][v.y] == 'a' && st(v.x - 1, v.y) != p) {
		if (dfsA(st(v.x - 1, v.y), v)) {
			g[v.x][v.y] = 'y';
			return true;
		}
	}
	if (g[v.x + 1][v.y] == 'a' && st(v.x + 1, v.y) != p) {
		if (dfsA(st(v.x + 1, v.y), v)) {
			g[v.x][v.y] = 'y';
			return true;
		}
	}


	if (g[v.x][v.y - 1] == 'b' && st(v.x, v.y - 1) != p) {
		if (dfsB(st(v.x, v.y - 1), v)) {
			g[v.x][v.y] = 'y';
			return true;
		}
	}
	if (g[v.x][v.y + 1] == 'b' && st(v.x, v.y + 1) != p) {
		if (dfsB(st(v.x, v.y + 1), v)) {
			g[v.x][v.y] = 'y';
			return true;
		}
	}
	if (g[v.x - 1][v.y] == 'b' && st(v.x - 1, v.y) != p) {
		if (dfsB(st(v.x - 1, v.y), v)) {
			g[v.x][v.y] = 'y';
			return true;
		}
	}
	if (g[v.x + 1][v.y] == 'b' && st(v.x + 1, v.y) != p) {
		if (dfsB(st(v.x + 1, v.y), v)) {
			g[v.x][v.y] = 'y';
			return true;
		}
	}

	g[v.x][v.y] = '?';
	return false;
}

bool dfsB(const st v, const st p) {
	g[v.x][v.y] = 'c';
	if (g[v.x][v.y - 1] == 'c' && st(v.x, v.y - 1) != p) {
		g[v.x][v.y] = 'y';
		return true;
	}
	if (g[v.x][v.y + 1] == 'c' && st(v.x, v.y + 1) != p) {
		g[v.x][v.y] = 'y';
		return true;
	}
	if (g[v.x - 1][v.y] == 'c' && st(v.x - 1, v.y) != p) {
		g[v.x][v.y] = 'y';
		return true;
	}
	if (g[v.x + 1][v.y] == 'c' && st(v.x + 1, v.y) != p) {
		g[v.x][v.y] = 'y';
		return true;
	}


	if (g[v.x][v.y - 1] == 'a' && st(v.x, v.y - 1) != p) {
		if (dfsA(st(v.x, v.y - 1), v)) {
			g[v.x][v.y] = 'y';
			return true;
		}
	}
	if (g[v.x][v.y + 1] == 'a' && st(v.x, v.y + 1) != p) {
		if (dfsA(st(v.x, v.y + 1), v)) {
			g[v.x][v.y] = 'y';
			return true;
		}
	}
	if (g[v.x - 1][v.y] == 'a' && st(v.x - 1, v.y) != p) {
		if (dfsA(st(v.x - 1, v.y), v)) {
			g[v.x][v.y] = 'y';
			return true;
		}
	}
	if (g[v.x + 1][v.y] == 'a' && st(v.x + 1, v.y) != p) {
		if (dfsA(st(v.x + 1, v.y), v)) {
			g[v.x][v.y] = 'y';
			return true;
		}
	}

	g[v.x][v.y] = '?';
	return false;
}

int main() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);

	cin >> n >> m;
	g.resize(n + 2, string(m + 2, '!'));
	for (ll i = 1; i <= n; ++i) {
		string t;
		cin >> t;
		g[i] = '!' + t + '!';
	}

	for (ll i = 1; i <= n; ++i) {
		if (g[i][1] == '.')
			dfs1(st(i, 1));
		if (g[i][m] == '.')
			dfs1(st(i, m));
	}
	for (ll j = 1; j <= m; ++j) {
		if (g[1][j] == '.')
			dfs1(st(1, j));
		if (g[n][j] == '.')
			dfs1(st(n, j));
	}

	for (ll i = 1; i <= n; ++i) {
		for (ll j = 1; j <= m; ++j) {
			if (okA(st(i, j)))
				g[i][j] = 'a';
		}
	}
	for (ll i = 1; i <= n; ++i) {
		for (ll j = 1; j <= m; ++j) {
			if (okB(st(i, j)))
				g[i][j] = 'b';
		}
	}

	auto showRes = [&]() {
		for (ll i = 1; i <= n; ++i) {
			for (ll j = 1; j <= m; ++j) {
				if (g[i][j] == 'y')
					cout << '#';
				else
					cout << '.';
			}
			cout << '\n';
		}
	};


	// cerr << "\n\n\n";
	for (ll i = 1; i <= n; ++i) {
		for (ll j = 1; j <= m; ++j) {
			if (okA(st(i, j))) {
				dfsA(st(i, j), st(-1, -1));
				g[i][j] = 'y';
				
				showRes();
				return 0;
			}
		}
	}
}