#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 227;

vector<vector<bool>> used;
vector<string> field;
vector<pair<int, int>> moves{{1, 0}, {-1, 0}, {0, -1}, {0, 1}};
int i_size, j_size;

void dfs(int i, int j) {
    used[i][j] = true;
    for (auto [di, dj]: moves) {
        int ni = i + di, nj = j + dj;
        if (0 <= ni && ni < i_size && 0 <= nj && nj < j_size) {
            if (field[ni][nj] == '.' && !used[ni][nj]) dfs(ni, nj);
        }
    }
}

void solve() {
    cin >> i_size >> j_size;
    field.resize(i_size);
    used.resize(i_size, vector<bool>(j_size, false));
    for (auto &i: field) cin >> i;
    for (int i = 0; i < i_size; i++) {
        if (field[i][0] == '.' && !used[i][0]) dfs(i, 0);
        if (field[i][j_size - 1] == '.' && !used[i][j_size - 1]) dfs(i, j_size - 1);
    }
    for (int j = 0; j < j_size; j++) {
        if (field[0][j] == '.' && !used[0][j]) dfs(0, j);
        if (field[i_size-1][j] == '.' && !used[i_size - 1][j]) dfs(i_size - 1, j);
    }
    int i_min = -1, i_max = -1, j_min = -1, j_max = -1;
    for (int i = 0; i < i_size; i++) {
        for (int j = 0; j < j_size; j++) {
            if (field[i][j] == '.' && !used[i][j]) {
                if (i_min == -1) {
                    i_min = i_max = i;
                    j_min = j_max = j;
                }
                i_min = min(i, i_min);
                i_max = max(i, i_max);
                j_min = min(j, j_min);
                j_max = max(j, j_max);
            }
        }
    }
    vector<vector<char>> answer(i_size, vector<char>(j_size, '.'));
    for (int i = i_min - 1; i <= i_max+1; i++) {
        answer[i][j_min - 1] = '#';
        answer[i][j_max + 1] = '#';
    }
    for (int j = j_min - 1; j <= j_max+1; j++) {
        answer[i_min - 1][j] = '#';
        answer[i_max + 1][j] = '#';
    }
    for (auto &v: answer) {
        for (char c: v) {
            cout << c;
        }
        cout << "\n";
    }
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

#ifdef local
    freopen("input", "r", stdin);
#endif // local

    solve();
}
