#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <deque>

using namespace std;
using ll = long long;
using ld = long double;
const ll inf = ll(1e18) * 2 + 36;

#define all(x) (x).begin(), (x).end()
#define fast() ios::sync_with_stdio(0); cin.tie(0)
#define rall(x) (x).rbegin(), (x).rend()

vector<ll> tree, p;

void build(ll v, ll l, ll r) {
	if (l == r - 1) {
		tree[v] = l;
		return;
	}
	ll mid = (l + r) / 2;
	build(2 * v + 1, l, mid);
	build(2 * v + 2, mid, r);
	if (tree[v * 2 + 2] == -inf) {
		tree[v] = tree[v * 2 + 1];
		return;
	}
	tree[v] = (p[tree[2 * v + 1]] <= p[tree[2 * v + 2]] ? tree[2 * v + 1] : tree[2 * v + 2]);
}
ll get(ll v, ll lv, ll rv, ll l, ll r) {
	if (lv >= r || l >= rv) return inf;
	if (l <= lv && rv <= r) return tree[v];
	ll mid = (lv + rv) / 2;
	auto t1 = get(2 * v + 1, lv, mid, l, r);
	auto t2 = get(2 * v + 2, mid, rv, l, r);
	if (t1 == inf) return t2;
	if (abs(t2) == inf) return t1;
	return (p[t1] <= p[t2] ? t1 : t2);
}
signed main() {
	fast();
	ll n, b, c;
	cin >> n >> b >> c;
	tree.resize(4 * (n + 1), -inf);
	p.resize(n);
	vector<ll> x(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> p[i];
	}
	x.push_back(inf);
	p.push_back(inf);
	n++;
	build(0, 0, n);
	ll i = 0, l = 0, V = 0;
	ll ans = 0;
	while (i < n) {
		ll v = min(b / p[i], (c - V));
		auto t = upper_bound(x.begin(), x.end(), v + V + x[i]) - x.begin();
		t--;
		if (i != t)
			l = get(0, 0, n, i + 1, t + 1ll);
		else {
			ans = max(ans, x[i] + V + v);
			break;
		}
		if (p[l] > p[i]) {
			V +=v;
			b -= v * p[i];
			if ((x[l] - x[i]) > V) {
				ans = max(ans, x[i] + V);
				break;
			} V -= x[l] - x[i];
			i = l;
		}
		else {
			ll u = min(v, x[l] - x[i]);
			V += u;
			b -= u * p[i];
			if ((x[l] - x[i]) > V) {
				ans = max(ans, x[i] + V);
				break;
			} V -= x[l] - x[i];
			i = l;
		}
	}
	cout << ans;
	return 0;
}