#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int maxn = 1000;

string s[maxn], ans[maxn];

bool used[maxn][maxn];

int n, m;

void dfs(int i, int j) {
    if (used[i][j]) {
        return;
    }
    used[i][j] = true;
    if (i + 1 < n && s[i + 1][j] == '.') {
        dfs(i + 1, j);
    }
    if (j + 1 < m && s[i][j + 1] == '.') {
        dfs(i, j + 1);
    }
    if (i > 0 && s[i - 1][j] == '.') {
        dfs(i - 1, j);
    }
    if (j > 0 && s[i][j - 1] == '.') {
        dfs(i, j - 1);
    }
}

void transform(vector<vector<char>> &a) {
    vector b(a[0].size(), vector<char>(a.size()));
    for (int i = 0; i < a.size(); ++i) {
        for (int j = 0; j < a[i].size(); ++j) {
            b[j][(int)(a.size()) - i - 1] = a[i][j];
        }
    }
    swap(a, b);
}


int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        ans[i].assign(m, '.');
    }
    for (int i = 0; i < n; ++i) {
        if (s[i][0] == '.')  {
            dfs(i, 0);
        }
        if (s[i][m - 1] == '.') {
            dfs(i, m - 1);
        }
    }
    for (int i = 0; i < m; ++i) {
        if (s[0][i] == '.') {
            dfs(0, i);
        }
        if (s[n - 1][i] == '.') {
            dfs(n - 1, i);
        }
    }

    int mni = n, mxi = 0, mnj = m, mxj = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (s[i][j] == '.' && !used[i][j]) {
                mni = min(mni, i);
                mxi = max(mxi, i);
                mnj = min(mnj, j);
                mxj = max(mxj, j);
            }
        }
    }

    for (int j = mnj - 1; j <= mxj + 1; ++j) {
        ans[mni - 1][j] = ans[mxi + 1][j] = '#';
    }

    for (int i = mni - 1; i <= mxi + 1; ++i) {
        ans[i][mnj - 1] = ans[i][mxj + 1] = '#';
    }

    for (int d = 0;; ++d) {
        if (mni - 1 + d > mxi + 1 - d || mnj - 1 + d > mxj + 1 - d) {
            break;
        }
        for (int j = mnj - 1 + d; j <= mxj + 1 - d; ++j) {
            int i = mni - 1 + d;
            if (ans[i][j] == '#' && s[i][j] == '.') {
                ans[i][j] = '.';
                if (j != mnj - 1 + d) {
                    ans[i + 1][j - 1] = '#';
                }
                if (j != mxj + 1 - d) {
                    ans[i + 1][j + 1] = '#';
                }
                ans[i + 1][j] = '#';
            }
            i = mxi + 1 - d;
            if (ans[i][j] == '#' && s[i][j] == '.') {
                ans[i][j] = '.';
                if (j != mnj - 1 + d) {
                    ans[i - 1][j - 1] = '#';
                }
                if (j != mxj + 1 - d) {
                    ans[i - 1][j + 1] = '#';
                }
                ans[i - 1][j] = '#';
            }
        }
        for (int j = mnj + d; j <= mxj + 1 - d; ++j) {
            int i = mni - 1 + d;
            if (s[i + 1][j + 1] != '.') {
                ans[i + 1][j + 1] = '#';
                ans[i][j] = '.';
            } else {
                break;
            }
        }
        for (int j = mnj + d; j <= mxj + 1 - d; ++j) {
            int i = mxi + 1 - d;
            if (s[i - 1][j + 1] != '.') {
                ans[i - 1][j + 1] = '#';
                ans[i][j] = '.';
            } else {
                break;
            }
        }
        for (int j = mxj - d; j >= mnj - 1 + d; --j) {
            int i = mni - 1 + d;
            if (s[i + 1][j - 1] != '.') {
                ans[i + 1][j - 1] = '#';
                ans[i][j] = '.';
            } else {
                break;
            }
        }
        for (int j = mxj - d; j >= mnj - 1 + d; --j) {
            int i = mxi + 1 - d;
            if (s[i - 1][j - 1] != '.') {
                ans[i - 1][j - 1] = '#';
                ans[i][j] = '.';
            } else {
                break;
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << ans[i] << '\n';
    }
    return 0;
}
