#include "bits/stdc++.h"

using namespace std;

typedef long long ll;
#define int ll

vector<pair<int, int>> moves{{1, 0}, {-1, 0}, {0, 1}, {0, -1}};

constexpr int inf = 1E9;

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    
    int n, m;
    cin >> n >> m;
    
    vector<string> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    
    vector<vector<bool>> once(n, vector<bool>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (!once[i][j] && s[i][j] == '.') {
                auto good = [&](int x, int y) {
                    return 0 <= x && x < n && 0 <= y && y < m && s[x][y] == '.' && !once[x][y];
                };
                vector<pair<int, int>> v;
                function<void(int, int)> dfs = [&](int x, int y) {
                    once[x][y] = true;
                    v.emplace_back(x, y);
                    for (auto [dx, dy] : moves) {
                        if (good(x + dx, y + dy)) {
                            dfs(x + dx, y + dy);
                        }
                    }
                };
                dfs(i, j);
                int mnx = n, mny = m, mxx = 0, mxy = 0;
                for (auto [x, y] : v) {
                    mnx = min(mnx, x);
                    mny = min(mny, y);
                    mxx = max(mxx, x);
                    mxy = max(mxy, y);
                }
                if (mnx > 0 && mny > 0 && mxx < n - 1 && mxy < m - 1) {
                    // lake
                    sort(v.begin(), v.end(), [&](auto a, auto b) {
                         return a.second < b.second;
                    });
                    auto [x, y] = v[0];
                    y--; // now free
//                    cout << x << " " << y << " is the one\n";
                    vector<vector<bool>> g(n, vector<bool>(m));
                    for (int j = 0; j <= y; j++) {
                        g[x - 1][j] = true;
                    }
                    for (int j = 0; j < y; j++) {
                        g[x][j] = true;
                    }
                    auto good = [&](int x, int y) {
                        return 0 <= x && x < n && 0 <= y && y < m && s[x][y] == '#' && !g[x][y];
                    };
                    auto bfs = [&](vector<vector<int>> &d, vector<vector<pair<int, int>>> &p, int x, int y) {
                        d[x][y] = 0;
                        queue<pair<int, int>> q;
                        q.push({x, y});
                        while (!q.empty()) {
                            auto [x, y] = q.front();
                            q.pop();
                            for (auto [dx, dy] : moves) {
                                int nx = x + dx;
                                int ny = y + dy;
                                if (good(nx, ny) && d[nx][ny] > d[x][y] + 1) {
                                    d[nx][ny] = d[x][y] + 1;
                                    p[nx][ny] = {x, y};
                                    q.push({nx, ny});
                                }
                            }
                        }
                    };
                    vector<vector<int>> da(n, vector<int>(m, inf));
                    vector<vector<pair<int, int>>> pa(n, vector<pair<int, int>>(m, {-1, -1}));
                    bfs(da, pa, x, y);
                    g = vector<vector<bool>>(n, vector<bool>(m));
                    for (int j = 0; j <= y; j++) {
                        g[x + 1][j] = true;
                    }
                    for (int j = 0; j < y; j++) {
                        g[x][j] = true;
                    }
                    
                    vector<vector<int>> db(n, vector<int>(m, inf));
                    vector<vector<pair<int, int>>> pb(n, vector<pair<int, int>>(m, {-1, -1}));
                    bfs(db, pb, x, y);
                    
                    int ax = 0, ay = 0;
                    for (int i = 0; i < n; i++) {
                        for (int j = 0; j < m; j++) {
                            if (!(i == x && j == y) && da[i][j] + db[i][j] < da[ax][ay] + db[ax][ay]) {
                                ax = i;
                                ay = j;
                            }
                        }
                    }
//                    for (int i = 0; i < n; i++) {
//                        for (int j = 0; j < m; j++) {
//                            cout << da[i][j] << " \n"[j == m-  1];
//                        }
//                    }
//                    for (int i = 0; i < n; i++) {
//                        for (int j = 0; j < m; j++) {
//                            cout << db[i][j] << " \n"[j == m-  1];
//                        }
//                    }
//                    cout << ax << " " << ay << "\n";
//                    cout << da[ax][ay] << "  " << db[ax][ay] << "\n";
//                    
                    assert(!(ax == x && ay == y));
                    vector<string> ans(n, string(m, '.'));
                    {
                        int x = ax, y = ay;
                        while (x != -1) {
                            ans[x][y] = '#';
                            auto [nx, ny] = pa[x][y];
                            x = nx;
                            y = ny;
                        }
                    }
                    {
                        int x = ax, y = ay;
                        while (x != -1) {
                            ans[x][y] = '#';
                            auto [nx, ny] = pb[x][y];
                            x = nx;
                            y = ny;
                        }
                    }
                    
                    for (int i = 0; i < n; i++) {
                        cout << ans[i] << "\n";
                    }
                    return 0;
                }
            }
        }
    }
    
    assert(false);
}

/*

10 3
.#.
###
#.#
#.#
#.#
#.#
#.#
###
#.#
.##


3 10
.#########
##.....#.#
.#######.#

*/
