#include <bits/stdc++.h>

using namespace std;
using uint = long long;

int main() {
    int n, m; cin >> n >> m;
    vector<string> g(n);
    for(auto &i : g) cin >> i;
    vector<vector<bool>> w(n, vector<bool>(m, false));
    vector<int> di = {1, 0, -1, 0};
    vector<int> dj = {0, 1, 0, -1};
    auto isValid = [&](int i, int j) {
        return i >= 0 && i < n && j >= 0 && j < m;
    };
    function<bool(int, int)> dfs = [&](int i, int j) {
        if(!isValid(i, j)) return false;
        if(g[i][j] == '#') return true;
        if(w[i][j]) return true;
        w[i][j] = 1;
        bool ok = 1;
        for(int k = 0; k < 4; k++) ok &= dfs(i + di[k], j + dj[k]);
        return ok;
    };
    int si = -1, sj = -1;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(g[i][j] == '.' && !w[i][j]) {
                bool ok = dfs(i, j);
                if(ok) {
                    si = i, sj = j;
                }
            }
        }
    }
    fill(w.begin(), w.end(), vector<bool>(m, false));
    int l = m + 1, r = -1, u = n + 1, d = -1;
    function<void(int, int)> get_anchors = [&](int i, int j) {
        if(w[i][j] || g[i][j] == '#') return true;
        w[i][j] = 1;
        l = min(l, j);
        r = max(r, j);
        u = min(u, i);
        d = max(d, i);
        for(int k = 0; k < 4; k++) get_anchors(i + di[k], j + dj[k]);
    };
    get_anchors(si, sj);
    vector<string> ng(n, string(m, '.'));
    ng[u - 1][l - 1] = '#';
    ng[u - 1][r + 1] = '#';
    ng[d + 1][l - 1] = '#';
    ng[d + 1][r + 1] = '#';
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(j == l - 1 || j == r + 1) {
                if(i >= u && i <= d) ng[i][j] = '#';
            }
            if(i == u - 1 || i == d + 1) {
                if(j >= l && j <= r) ng[i][j] = '#';
            }
        }
    }
    for(auto i : ng) {
        cout << i << endl;
    }
    return 0;
}
