#include <iostream>
#include <vector>
#include <tuple>
#include <set>
#include<queue>
#define int long long

using namespace std;

const int INF = 1000000000000000;
int MOD = 1000000000 + 7;


vector<vector<tuple<int, int>>> g(200001);

vector<int> d_s(200002, INF);
vector<int> d_f(200002, INF);


vector<int> cnt_s(200002, 0);
vector<int> cnt_f(200002, 0);


priority_queue<pair<int,int>, vector<pair<int,int>>, greater<pair<int,int>>> q;
void dei_s(int n, int s){
    int start = s;
    d_s[start] = 0;
    q.push({0, start});
    while(!q.empty()){
        int c = q.top().first,
            v = q.top().second;
        q.pop();
        if(c > d_s[v]) continue;

        for(auto x : g[v]){
            if(d_s[get<1>(x)] > d_s[v] + get<0>(x)){
                d_s[get<1>(x)] = d_s[v] + get<0>(x);
                q.push({d_s[get<1>(x)], get<1>(x)});
                cnt_s[get<1>(x)] = 1;
            }
            else if(d_s[get<1>(x)] == d_s[v] + get<0>(x))
                cnt_s[get<1>(x)]++;
        }

    }
}

void dei_f(int n, int s){
    int start = s;
    d_f[start] = 0;
    q.push({0, start});
    while(!q.empty()){
        int c = q.top().first,
            v = q.top().second;
        q.pop();
        if(c > d_f[v]) continue;

        for(auto x : g[v]){
            if(d_f[get<1>(x)] > d_f[v] + get<0>(x)){
                d_f[get<1>(x)] = d_f[v] + get<0>(x);
                q.push({d_f[get<1>(x)], get<1>(x)});
                cnt_f[get<1>(x)] = 1;
            }
            else if(d_f[get<1>(x)] == d_f[v] + get<0>(x))
                cnt_f[get<1>(x)]++;
        }

    }
}

signed main()
{
    int n, m;
    cin >> n >> m;
    int st, fin, L;
    cin >> st >> fin >> L;
    st--;
    fin--;
    for(int i = 0; i < m; i++){
        int u, v, c;
        cin >> u >> v >> c;
        u--;
        v--;
        g[v].push_back({c, u});
        g[u].push_back({c, v});
    }
    dei_s(n, st);
    dei_f(n, fin);
    cnt_s[st] = 1;
    cnt_f[fin] = 1;
    int ans = 0;
    int dist = d_s[fin];
    for(int v = 0; v < n; v++){
        if(d_s[v] + d_f[v] == dist){
            for(auto x : g[v]){

                if(d_s[v] + d_f[get<1>(x)] + get<0>(x) == L && v != fin){
                    ans += cnt_s[v] * cnt_f[get<1>(x)];
                    ans %= MOD;
                }
            }
        }

    }

    cout << ans;

    return 0;
}

/*

3 2
1 3 4
1 2 2
2 3 1


6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4
*/
