#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using namespace std;

template<typename T>
bool rmax(T& a, T b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
bool rmin(T& a, T b) {
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T>& a) {
    for (auto &it : a) {
        in << it << ' ';
    }
    return in;
}

struct SegmentTree {
    vector<pii> tree;
    int n;

    void upd(int v, int l) {
        tree[v + n] = {l, v};
        for (v += n; v > 1; v >>= 1) {
            tree[v >> 1] = min(tree[v], tree[v ^ 1]);
        }
    }

    pii get(int l, int r) {
        pii res = {2e18, 2e18};
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                rmin(res, tree[l++]);
            }

            if (r & 1) {
                rmin(res, tree[--r]);
            }
        }

        return res;
    }

    void init(int n) {
        tree.resize(4 * n);
        this->n = n;
    }
};

void solve() {
    int n, b, c;
    cin >> n >> b >> c;

    vector<int> dist(n);
    SegmentTree tree;
    vector<int> costs(n);
    tree.init(n);

    for (int i = 0; i < n; i++) {
        cin >> dist[i];
        int p;
        cin >> p;
        costs[i] = p;

        tree.upd(i, p);
    }

    int curr_benz = 0;
    for (int l = 0; l < n;) {
        int r = n;
        int l1 = l;
        while (r - l1 > 1) {
            int tm = (l1 + r) / 2;
            if (dist[tm] - dist[l] <= c && dist[tm] - dist[l] <= curr_benz + b / costs[l]) {
                l1 = tm;
            } else {
                r = tm;
            }
        }

        if (l1 == l) {
            cout << dist[l] + min(c, curr_benz + b / costs[l]) << endl;
            return;
        }

        pii good = tree.get(l + 1, r);
        if (good.X <= costs[l]) {
            int dst = dist[good.Y] - dist[l];
            int mi_sd = dst - curr_benz;
            if (mi_sd < 0) {
                curr_benz -= dst;
            } else {
                curr_benz = 0;
                b -= costs[l] * mi_sd;
                assert(b >= 0);
            }
            l = good.Y;
        } else {
            int val = b / costs[l];
            b -= costs[l] * (c - curr_benz);
            if (b < 0) {
                b = 0;
                curr_benz += val - (dist[good.Y] - dist[l]);
            } else {
                curr_benz = c - (dist[good.Y] - dist[l]);
            }
            l = good.Y;
            assert(b >= 0);
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("..\\input.txt", "r", stdin);
    freopen("..\\output.txt", "w", stdout);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}