#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using namespace std;

template<typename T>
bool rmax(T& a, T b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
bool rmin(T& a, T b) {
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T>& a) {
    for (auto &it : a) {
        in << it << ' ';
    }
    return in;
}

const int INF = 1e3 + 1;
vector<pii> good = {{-1, 0}, {1, 0}, {0, 1}, {0, -1}};
int used[INF][INF];
pii pr[INF][INF];
char matr[INF][INF];
int n;
int m;
vector<vector<pii>> lake;

bool check(int x, int y) {
    return (x >= 0 && x < n && y >= 0 && y < m);
}

void dfs(int x, int y, int col) {
    used[x][y] = col;

//    cout << x << ' ' << y << ' ' << col << endl;
    for (auto &it : good) {
        int x1 = x + it.X;
        int y1 = y + it.Y;

        if (check(x1, y1) && used[x1][y1] == -1 && matr[x1][y1] == '.') {
            dfs(x1, y1, col);
        }
    }
}

void bfs(pii x, pii y) {
    queue<pii> q;
    q.push(x);
    pr[x.X][x.Y] = {-1, -1};
    int ma_x = x.X;

    while (!q.empty()) {
        pii v = q.front();
        q.pop();

        int x1 = v.X;
        int y1 = v.Y;

        used[x1][y1] = -2;

        for (auto &it : good) {
            int nx = x1 + it.X;
            int ny = y1 + it.Y;

            pii fg = {nx, ny};
            if (v == x && fg == y) {
                continue;
            }

            if (check(nx, ny) && used[nx][ny] != -2 && matr[nx][ny] == '#' && nx >= ma_x) {
                q.push({nx, ny});
                pr[nx][ny] = v;
//                cout << x1 << ' ' << y1 << endl;
//                cout << nx << ' ' << ny << endl;
//                cout << endl;
                used[nx][ny] = -2;
            }
        }
    }
}

void solve() {
    cin >> n >> m;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            used[i][j] = -1;
            cin >> matr[i][j];
        }
    }

    int col = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (used[i][j] == -1 && matr[i][j] == '.') {
                dfs(i, j, col++);
            }
        }
    }

    bool is_good[col];
    fill(is_good, is_good + col, 0);

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (matr[i][j] == '#') {
                continue;
            }

            if (i == 0 || j == 0 || i + 1 == n || j + 1 == m) {
                is_good[used[i][j]] = 1;
            }
        }
    }

    int the_best = 0;
    for (int i = 0; i < col; i++) {
        if (!is_good[i]) {
            the_best = i;
        }
    }

    pii my = {-1, 0};
//    cout << the_best << endl;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (used[i][j] == the_best) {
//                cout << i << ' ' << j << endl;
                my = {i - 1, j - 1};
                break;
            }
        }
        if (my.X != -1) {
            break;
        }
    }

//    cout << my.X << ' ' << my.Y << endl;
    bfs(my, {my.X, my.Y + 1});


    pii x1 = {my.X, my.Y + 1};
//    cout << pr[x1.X][x1.Y].Y << endl;
    while (x1 != my) {
        used[x1.X][x1.Y] = -3;
        x1 = pr[x1.X][x1.Y];
    }

    used[my.X][my.Y] = -3;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (used[i][j] == -3) {
                cout << '#';
            } else {
                cout << '.';
            }
        }
        cout << endl;
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("..\\input.txt", "r",  stdin);
    freopen("..\\output.txt", "w", stdout);
#endif

    int t  = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}