#include <iostream>
#include <vector>
#include <cmath>

#define MOD 1000000007

using namespace std;

vector<vector<long long>> dp(400, vector<long long>(400, -1));
vector<vector<long long>> dpcnt(400, vector<long long>(400, -1));

int min(int a, int b) {
	return (a < b) ? a : b;
}

pair<long long, long long> f(long long h, long long w) {
	if (dp[h][w] != -1) {
		return make_pair(dp[h][w], dpcnt[h][w]);
	}
	int sum = h * w;
	long long H = h, W = w;
	h -= 2;
	w -= 2;
	long long cnt = 1;
	for (long long i = 1; i <= h; ++i) {
		sum = (sum + ((h - i + 1) * w * (dp[i][1] + H * W)) % MOD) % MOD;
		cnt += (h - i + 1) * w;
		if (w >= 2) {
			sum = (sum + ((h - i + 1) * (w - 1) * (dp[i][2] + H * W)) % MOD) % MOD;
			cnt += (h - i + 1) * (w - 1);
		}
	}
	
	for (long long i = 3; i <= w; ++i) {
		sum = (sum + (h * (w - i + 1) * (dp[1][i] + H * W)) % MOD) % MOD;
		cnt += h * (w - i + 1);
		if (h >= 2) {
			sum = (sum + ((h - 1) * (w - i + 1) * (dp[2][i] + H * W)) % MOD) % MOD;
			cnt += (h - 1) * (w - i + 1);
		}
	}

	for (long long i = 3; i <= h; ++i) {
		for (long long j = 3; j <= w; ++j) {
			pair<long long, long long> t = f(i, j);
			sum = (sum + ((h - i + 1) * (w - j + 1) * (t.first + H * W * t.second)) % MOD) % MOD;
			cnt += t.second * ((h - i + 1) * (w - j + 1));
		}
	}
	dp[h][w] = sum;
	dpcnt[h][w] = cnt;
	return make_pair(sum, cnt);;
}

int main() {	
	int h, w;
	cin >> h >> w;
	for (long long int i = 1; i <= h; ++i) {
		dp[i][1] = i;
		dp[2][i] = i * 2;
		dpcnt[1][i] = i;
		dpcnt[2][i] = i;
	}
	for (long long int i = 1; i <= w; ++i) {
		dp[1][i] = i;
		dp[i][2] = i * 2;
		dpcnt[1][i] = i;
		dpcnt[i][2] = i;
	}

	cout << f(h, w).first;
}