#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(666);

struct node {
    long long mn, mx;
};

int n;
long long a[500500];
node t1[2000000], t2[2000000];

void build1(int v, int tl, int tr) {
    if (tl == tr) {
        t1[v].mn = t1[v].mx = a[tl] + a[n - tl];
        return;
    }
    int md = (tl + tr) / 2;
    build1(v * 2, tl, md);
    build1(v * 2 + 1, md + 1, tr);
    t1[v].mn = min(t1[v * 2].mn, t1[v * 2 + 1].mn);
    t1[v].mx = max(t1[v * 2].mx, t1[v * 2 + 1].mx);
}

void build2(int v, int tl, int tr) {
    if (tl == tr) {
        t2[v].mn = t2[v].mx = a[tl] + a[n - tl + 2];
        return;
    }
    int md = (tl + tr) / 2;
    build2(v * 2, tl, md);
    build2(v * 2 + 1, md + 1, tr);
    t2[v].mn = min(t2[v * 2].mn, t2[v * 2 + 1].mn);
    t2[v].mx = max(t2[v * 2].mx, t2[v * 2 + 1].mx);
}

long long get_max_1(int v, int tl, int tr, int l, int r) {
    if (tl > r || tr < l)
        return -2e18;
    if (tl >= l && tr <= r)
        return t1[v].mx;
    int md = (tl + tr) / 2;
    return max(get_max_1(v * 2, tl, md, l, r), get_max_1(v * 2 + 1, md + 1, tr, l, r));
}

long long get_max_2(int v, int tl, int tr, int l, int r) {
    if (tl > r || tr < l)
        return -2e18;
    if (tl >= l && tr <= r)
        return t2[v].mx;
    int md = (tl + tr) / 2;
    return max(get_max_2(v * 2, tl, md, l, r), get_max_2(v * 2 + 1, md + 1, tr, l, r));
}

long long get_min_1(int v, int tl, int tr, int l, int r) {
    if (tl > r || tr < l)
        return 2e18;
    if (tl >= l && tr <= r)
        return t1[v].mn;
    int md = (tl + tr) / 2;
    return min(get_min_1(v * 2, tl, md, l, r), get_min_1(v * 2 + 1, md + 1, tr, l, r));
}

long long get_min_2(int v, int tl, int tr, int l, int r) {
    if (tl > r || tr < l)
        return 2e18;
    if (tl >= l && tr <= r)
        return t2[v].mn;
    int md = (tl + tr) / 2;
    return min(get_min_2(v * 2, tl, md, l, r), get_min_2(v * 2 + 1, md + 1, tr, l, r));
}

long long fast() {
    long long ans = 2e18;

    long long mx1[n + 10] = {}, mn1[n + 10] = {};
    mx1[0] = -2e18, mn1[0] = 2e18;
    for (int i = 1; i <= n; i++) {
        mx1[i] = max(mx1[i - 1], a[i] + a[n - i + 1]);
        mn1[i] = min(mn1[i - 1], a[i] + a[n - i + 1]);
    }

    long long mx2[n + 10] = {}, mn2[n + 10] = {};
    mx2[n + 1] = -2e18, mn2[n + 1] = 2e18;
    for (int i = n; i >= 1; i--) {
        mx2[i] = max(mx2[i + 1], a[i] + a[n - i + 1]);
        mn2[i] = min(mn2[i + 1], a[i] + a[n - i + 1]);
    }

    for (int del = 1; del <= n; del++) {
        long long mn = 2e18, mx = -2e18, cnt = 0;

        mx = max(mx, mx1[min(n - del + 1, del) - 1]);
        mn = min(mn, mn1[min(n - del + 1, del) - 1]);


        mx = max(mx, mx2[max(del, n - del + 1) + 1]);
        mn = min(mn, mn2[max(del, n - del + 1) + 1]);

        mx = max(mx, get_max_1(1, 1, n, min(n - del + 1, del), del - 1));
        mn = min(mn, get_min_1(1, 1, n, min(n - del + 1, del), del - 1));


//        for (int i = min(n - del + 1, del); i < del; i++) {
//            mx = max(mx, a[i] + a[n - i]);
//            mn = min(mn, a[i] + a[n - i]);
//        }

        mx = max(mx, get_max_2(1, 1, n, del + 1, max(del, n - del + 1)));
        mn = min(mn, get_min_2(1, 1, n, del + 1, max(del, n - del + 1)));

//        for (int i = max(del, n - del + 1); i > del; i--) {
//            mx = max(mx, a[i] + a[n - i + 2]);
//            mn = min(mn, a[i] + a[n - i + 2]);
//        }

        ans = min(ans, mx - mn);
    }
    return ans;
}

long long slow() {
    long long ans = 2e18;
    for (int del = 1; del <= n; del++) {
        vector<long long> ve = {0};
        for (int i = 1; i <= n; i++)
            if (i != del)
                ve.push_back(a[i]);
        long long mn = 2e18, mx = -2e18;
        for (int i = 1; i <= n - 1; i++) {
            mn = min(mn, ve[i] + ve[n - i]);
            mx = max(mx, ve[i] + ve[n - i]);
        }
        ans = min(ans, mx - mn);
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
    sort(a + 1, a + n + 1);
    build1(1, 1, n);
    build2(1, 1, n);
    cout << fast() << '\n';
//    while (true) {
//        n = rnd() % 20;
//        if (n < 3) continue;
//        if (n % 2 == 0)
//            n++;
//        for (int i = 1; i <= n; i++)
//            a[i] = rnd() % 50 + 1;
//        build1(1, 1, n);
//        build2(1, 1, n);
//        sort(a + 1, a + n + 1);
//        if (fast() != slow()) {
//            cout << "caught!" << '\n';
//            cout << n << '\n';
//            for (int i = 1; i <= n; i++) cout << a[i] << ' ';
//            cout << '\n';
//            cout << "slow : " << slow() << '\n' << "fast : " << fast() << '\n';
//            return 0;
//        }
//    }
}

/**
9
1 3 5 9 18 25 25 36 38
11
1 3 23 26 39 39 40 42 47 48 50
11
5 9 15 19 22 25 26 38 42 46 47
9
1 19 23 39 42 46 47 48 50
**/
