#include <bits/stdc++.h>
using namespace std;

#define int long long
typedef long long ll;
typedef long double ld;

const int MX = 1e6 + 2;
const int INF32 = 2e9 + 5;
const int INF64 = 2e18 + 7;

int n, m;

bool check(int i, int j) {
    return i >= 0 && j >= 0 && i < n && j < m;
}

void dfs(int i, int j, vector<vector<char>> &a, vector<vector<bool>> &used, int &mxx, int&mxy, int& mny, int& mnx) {
    mxx = max(mxx, i);
    mnx = min(mnx, i);
    mxy = max(mxy, j);
    mny = min(mny, j);

    used[i][j] = true;
    if(check(i - 1, j)) {
        if(!used[i - 1][j] && a[i - 1][j] == '.') {
            dfs(i - 1, j, a, used, mxx, mxy, mny, mnx);
        }
    }
    if(check(i, j - 1)) {
        if(!used[i][j-1] && a[i][j - 1] == '.') {
            dfs(i, j-1, a, used, mxx, mxy, mny, mnx);
        }
    }
    if(check(i+1, j)) {
        if(!used[i+1][j] && a[i + 1][j] == '.') {
            dfs(i+1, j, a, used, mxx, mxy, mny, mnx);
        }
    }
    if(check(i, j+1)) {
        if(!used[i][j+1] && a[i][j + 1] == '.') {
            dfs(i, j+1, a, used, mxx, mxy, mny, mnx);
        }
    }
}

void f(int i, int j, int i1, int j1) {
    vector<vector<char>> ans(n, vector<char>(m, '.'));
    for(int o = i -1; o <= i1 + 1; ++o) {
        ans[o][j - 1] = '#';
        ans[o][j1 + 1] = '#';
    }
    for(int o = j - 1; o <= j1 + 1; ++o) {
        ans[i - 1][o] = '#';
        ans[i1 + 1][o] = '#';
    }
    for(auto &to : ans) {
        for(auto x : to) {
            cout << x;
        }
        cout << '\n';
    }
}

void solve() {
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    vector<vector<bool>> used(n, vector<bool> (m, false));
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            if(!used[i][j] && a[i][j] == '.') {
                int mxx = 0, mnx = n, mxy = 0, mny = m;
                dfs(i, j, a, used, mxx, mxy, mny, mnx);
                if(mxx < n - 1 && mny > 0 && mnx > 0 && mxy < m - 1) {
                    f(mnx, mny, mxx, mxy);
                    return;
                }
            }
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) solve();
    return 0;
}
