#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include<map>
#include <queue>

using namespace std;
typedef long long ll;

const ll M = 1e9 + 7;
const int N = 2e5 + 10;

ll pls(ll a, ll b){
    return (a + b) % M;
}

ll mult(ll a, ll b){
    return (a * b) % M;
}

vector<pair<ll, ll>> g[N];
ll to[N], cnt[N];
ll eto[N], ecnt[N];
bool red[N];
bool used[N];
ll L;

ll ans = 0;

void dfs(int v){
    used[v] = 1;
    for (auto [i, w] : g[v]){
        if (!used[i] && red[i])
            dfs(i);
        if (eto[i] + to[v] + w == L)
            ans = pls(ans, mult(cnt[v], ecnt[i]));
        //cout << mult(to[v], eto[v]) << '\n';

    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n, m;
    cin >> n >> m;
    ll s, t;
    cin >> s >> t >> L;
    for (int i = 0; i < m; i ++){
        int a, b;
        ll w;
        cin >> a >> b >> w;
        a--, b--;
        g[a].emplace_back(b, w);
        g[b].emplace_back(a, w);
    }
    s--, t--;
    for (int i = 0; i < n; i ++)
        to[i] = -1, eto[i] = -1;
    to[s] = 0, eto[t] = 0;
    priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, greater<pair<ll, ll>>> q;
    q.push({0ll, s});

    cnt[s] = 1;
    while(!q.empty()){
        auto [a, b] = q.top();
        q.pop();
        if (a > to[b])
            continue;
        for (auto i : g[b]){
            if (to[i.first] == -1)
                to[i.first] = a + i.second, cnt[i.first] = cnt[b], q.push({to[i.first], i.first});
            else if (to[i.first] == a + i.second)
                cnt[i.first] = pls(cnt[i.first], cnt[b]);
            else if (to[i.first] > a + i.second) {
                to[i.first] = a + i.second;
                cnt[i.first] = cnt[b];
                q.push({to[i.first], i.first});
            }
        }
    }

    q.push({0ll, t});
    ecnt[t] = 1;
    while(!q.empty()){
        auto [a, b] = q.top();
        q.pop();
        if (a > eto[b])
            continue;
        for (auto i : g[b]){
            if (eto[i.first] == -1)
                eto[i.first] = a + i.second, ecnt[i.first] = ecnt[b], q.push({eto[i.first], i.first});
            else if (eto[i.first] == a + i.second)
                ecnt[i.first] = pls(ecnt[i.first], ecnt[b]);
            else if (eto[i.first] > a + i.second) {
                eto[i.first] = a + i.second;
                ecnt[i.first] = ecnt[b];
                q.push({eto[i.first], i.first});
            }
        }
    }
    if (to[t] == L) {
        ans = cnt[t];
        cout << cnt[t] << '\n';
        return 0;
    }
    for (int i = 0; i < n; i ++){
        if (eto[i] + to[i] == to[t]){
            red[i] = 1;
        }
    }
    used[s] = 1;
    dfs(s);
    cout << ans << '\n';
    return 0;
}
/*
6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4
 */
