#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>

using namespace std;

#define endl '\n'
#define int long long
typedef long double ld;
const int INF = 1e18;

struct Node {
	int mn = INF, id = -1;
};

struct SegTree {
	vector <Node> t;
	int n;
	SegTree(int _n) {
		n = 4 * _n;
		t.resize(n);
	}
	void unite(const Node& l, const Node& r, Node& m) {
		if (l.mn <= r.mn) {
			m = l;
		}
		else {
			m = r;
		}
	}
	void build(int v, int l, int r, vector <pair <int, int> >& a) {
		if (l == r) {
			t[v].mn = a[l].second;
			t[v].id = l;
		}
		else {
			int m = (l + r) / 2;
			build(2 * v, l, m, a);
			build(2 * v + 1, m + 1, r, a);
			unite(t[2 * v], t[2 * v + 1], t[v]);
		}
	}
	Node Query(int v, int L, int R, int l, int r) {
		if (R < l || L > r) {
			return { INF, -1 };
		}
		else if (l <= L && r >= R) {
			return t[v];
		}
		else {
			int M = (L + R) / 2;
			Node LL = Query(2 * v, L, M, l, r), RR = Query(2 * v + 1, M + 1, R, l, r), MM;
			unite(LL, RR, MM);
			return MM;
		}
	}
};

void solve() {
	int n, b, c, i, j, del;
	cin >> n >> b >> c;
	int dist = 0;
	vector <pair <int, int> > a(n);
	int c1 = 0;
	for (i = 0; i < n; i++) {
		cin >> a[i].first >> a[i].second;
	}
	SegTree tree(n);
	tree.build(1, 0, n - 1, a);
	int id = 0;
	Node res;
	while (true) {
		int l = id, r = n, m;
		del = min(c, c1 + b / a[id].second);
		while (r - l > 1) {
			m = (l + r) / 2;
			if (a[m].first - a[id].first > del) {
				r = m;
			}
			else {
				l = m;
			}
		}
		if (r == id + 1) {
			dist += del;
			break;
		}
		else {
			res = tree.Query(1, 0, n - 1, id + 1, l);
			if (res.mn < a[id].second) {
				for (i = id + 1; i < n; i++) {
					if (a[i].second < a[id].second) {
						del = a[i].first - a[id].first;
						if (del > c1) {
							b -= (del - c1) * a[id].second;
							c1 = del;
						}
						else {
							//Pohuy
						}
						c1 -= del;
						dist += del;
						id = i;
						break;
					}
				}
			}
			else {
				b -= (c - c1) * a[id].first;
				c1 = c;
				i = res.id;
				del = a[i].first - a[id].first;
				dist += del;
				c1 -= del;
				id = i;
			}
		}
	}
	cout << dist << endl;
}

signed main() {
	int t = 1;
	//cin >> t;
	while (t--) solve();
}