#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#define all(a) a.begin(), a.end()

using namespace std;

typedef vector<int> vi;
typedef long long ll;
typedef vector<long long> vll;
typedef pair<int, int> pii;

#define int long long 

const ll INF = 1e18;

struct sgmn {
	vector<ll> t, add;
	ll undef = INF;
	int n;


	void built(int v, int vl, int vr, vector<int>& a) {
		if (vl == vr) {
			t[v] = a[vl];
			return;
		}
		int vm = (vl + vr) / 2;
		built(2 * v + 1, vl, vm, a);
		built(2 * v + 2, vm + 1, vr, a);
		t[v] = min(t[2 * v + 1], t[2 * v + 2]);
	}

	sgmn(int n_, vector<int>& a) {
		n = n_;
		t.resize(4 * n, INF);
		add.resize(4 * n, 0);
		built(0, 0, n - 1, a);
	}

	void push(int v, int vl, int vr) {
		if (add[v]) {
			t[v] += add[v] * (vr - vl + 1);
			if (vl != vr) {
				add[2 * v + 1] += add[v];
				add[2 * v + 2] += add[v];
			}
			add[v] = 0;
		}
	}

	ll query(int v, int vl, int vr, int l, int r) {
		push(v, vl, vr);
		if (r < vl || vr < l) {
			return INF;
		}
		if (l <= vl && vr <= r) {
			return t[v];
		}
		int vm = (vl + vr) / 2;
		ll ql = query(2 * v + 1, vl, vm, l, r);
		ll qr = query(2 * v + 2, vm + 1, vr, l, r);
		return min(ql, qr);
	}

	void modiy(int v, int vl, int vr, int l, int r, int val) {
		push(v, vl, vr);
		if (r < vl || vr < l) {
			return;
		}
		if (l <= vl && vr <= r) {
			add[v] = val;
			push(v, vl, vr);
			return;
		}
		int vm = (vl + vr) / 2;
		modiy(2 * v + 1, vl, vm, l, r, val);
		modiy(2 * v + 2, vm + 1, vr, l, r, val);
		t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
	}
};
struct sgma {
	vector<ll> t, add;
	ll undef = INF;
	int n;


	void built(int v, int vl, int vr, vector<int>& a) {
		if (vl == vr) {
			t[v] = a[vl];
			return;
		}
		int vm = (vl + vr) / 2;
		built(2 * v + 1, vl, vm, a);
		built(2 * v + 2, vm + 1, vr, a);
		t[v] = max(t[2 * v + 1], t[2 * v + 2]);
	}

	sgma(int n_, vector<int>& a) {
		n = n_;
		t.resize(4 * n, -INF);
		add.resize(4 * n, 0);
		built(0, 0, n - 1, a);
	}

	void push(int v, int vl, int vr) {
		if (add[v]) {
			t[v] += add[v] * (vr - vl + 1);
			if (vl != vr) {
				add[2 * v + 1] += add[v];
				add[2 * v + 2] += add[v];
			}
			add[v] = 0;
		}
	}

	ll query(int v, int vl, int vr, int l, int r) {
		push(v, vl, vr);
		if (r < vl || vr < l) {
			return -INF;
		}
		if (l <= vl && vr <= r) {
			return t[v];
		}
		int vm = (vl + vr) / 2;
		ll ql = query(2 * v + 1, vl, vm, l, r);
		ll qr = query(2 * v + 2, vm + 1, vr, l, r);
		return max(ql, qr);
	}

	void modiy(int v, int vl, int vr, int l, int r, int val) {
		push(v, vl, vr);
		if (r < vl || vr < l) {
			return;
		}
		if (l <= vl && vr <= r) {
			add[v] = val;
			push(v, vl, vr);
			return;
		}
		int vm = (vl + vr) / 2;
		modiy(2 * v + 1, vl, vm, l, r, val);
		modiy(2 * v + 2, vm + 1, vr, l, r, val);
		t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
	}
};


void solve() {
	int n;
	cin >> n;
	vector<int> L(n);
	for (auto& i : L)cin >> i;
	sort(all(L));
	vector<int> dl;
	int lst = n - 1;
	for (int i = 0; i < lst; i++) {
		dl.push_back(L[i] + L[lst]);
		//cout << dl.back() << ' ';
		lst--;
	}
	//cout << endl;
	sgmn Mi(dl.size(), dl);
	sgma Ma(dl.size(), dl);
	int ans = INF;
	for (int i = 1; i < n - 1; i++) {
		if (i == n / 2)continue;
		int ntk = min(i, n - i - 1);
		int dlt = L[i + 1] - L[i];
		if (i > n / 2) {
			dlt = L[i - 1] - L[i];
		}
		//cout << i << ' ' << ntk << ' ' << dlt << ' ' << Ma.query(0, 0, dl.size() - 1, ntk, dl.size() - 1) << endl;
		Mi.modiy(0, 0, dl.size() - 1, ntk, dl.size() - 1, dlt);
		Ma.modiy(0, 0, dl.size() - 1, ntk, dl.size() - 1, dlt);
		//cout << Ma.query(0, 0, dl.size() - 1, ntk, dl.size() - 1) << endl;
		//cout << Ma.query(0, 0, dl.size() - 1, 0, dl.size() - 1) << ' ' << Mi.query(0, 0, dl.size() - 1, 0, dl.size() - 1) << endl;
		ans = min(ans, Ma.query(0, 0, dl.size() - 1, 0, dl.size() - 1) - Mi.query(0, 0, dl.size() - 1, 0, dl.size() - 1));
		Mi.modiy(0, 0, dl.size() - 1, ntk, dl.size() - 1, -dlt);
		Ma.modiy(0, 0, dl.size() - 1, ntk, dl.size() - 1, -dlt);
	}
	//cout << ans << endl;
	sort(all(L));
	dl.clear();
	lst = n - 1;
	for (int i = 1; i < lst; i++) {
		dl.push_back(L[i] + L[lst]);
		lst--;
	}
	sort(all(dl));
	ans = min(ans, dl.back() - dl[0]);
	dl.clear();
	lst = n - 2;
	for (int i = 0; i < lst; i++) {
		dl.push_back(L[i] + L[lst]);
		lst--;
	}
	sort(all(dl));
	ans = min(ans, dl.back() - dl[0]);
	dl.clear();
	lst = n - 1;
	for (int i = 0; i < lst; i++) {
		dl.push_back(L[i] + L[lst]);
		lst--;
	}
	sort(all(dl));
	ans = min(ans, dl.back() - dl[0]);
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
