#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <string>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;
typedef long long ll;
typedef long double ld;
const long long INF = 1e18;
const int32_t MAXN = 2E5;
const int64_t MOD = 1E9 + 7;

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Mod_int
{
	int ans;
	Mod_int(const int64_t& ans = 0) :ans(ans% MOD) {}
	Mod_int operator+(const Mod_int& x) const
	{
		return ans + x.ans;
	}
	Mod_int operator-(const Mod_int& x) const
	{
		return (ans - x.ans + MOD) % MOD;
	}
	Mod_int operator+=(const Mod_int& x)
	{
		return *this = *this + x;
	}
	Mod_int operator* (const Mod_int& x) const
	{
		return int64_t(ans) * x.ans;
	}
	Mod_int operator*=(const Mod_int& x)
	{
		return *this = *this * x;
	}
};

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	ll h, w;
	cin >> h >> w;
	vector<vector<Mod_int>> qv(h + 1, vector<Mod_int>(w + 1, 1)), pref_qv(h + 1, vector<Mod_int>(w + 1, 0)), pref_qv_2(h + 1, vector<Mod_int>(w + 1, 0));
	for (ll i = 1; i <= 2; i++) {
		for (ll j = 1; j <= w; j++) {
			pref_qv[i][j] = pref_qv[i - 1][j] + pref_qv[i][j - 1] - pref_qv[i - 1][j - 1] + qv[i][j];
			pref_qv_2[i][j] = pref_qv_2[i - 1][j] + pref_qv_2[i][j - 1] - pref_qv_2[i - 1][j - 1] + pref_qv[i][j];
		}
	}

	for (ll i = 1; i <= h; i++) {
		for (ll j = 1; j <= 2; j++) {
			pref_qv[i][j] = pref_qv[i - 1][j] + pref_qv[i][j - 1] - pref_qv[i - 1][j - 1] + qv[i][j];
			pref_qv_2[i][j] = pref_qv_2[i - 1][j] + pref_qv_2[i][j - 1] - pref_qv_2[i - 1][j - 1] + pref_qv[i][j];
		}
	}

	for (ll i = 3; i <= h; i++) {
		for (ll j = 3; j <= w; j++) {
			qv[i][j] = pref_qv_2[i - 2][j - 2] + 1;
			pref_qv[i][j] = pref_qv[i - 1][j] + pref_qv[i][j - 1] - pref_qv[i - 1][j - 1] + qv[i][j];
			pref_qv_2[i][j] = pref_qv_2[i - 1][j] + pref_qv_2[i][j - 1] - pref_qv_2[i - 1][j - 1] + pref_qv[i][j];
		}
	}

	vector<vector<Mod_int>> ans(h + 1, vector<Mod_int>(w + 1, 1)), pref_ans(h + 1, vector<Mod_int>(w + 1, 0)), pref_ans_2(h + 1, vector<Mod_int>(w + 1, 0));
	for (ll i = 1; i <= 2; i++) {
		for (ll j = 1; j <= w; j++) {
			ans[i][j] = i * j;
			pref_ans[i][j] = pref_ans[i - 1][j] + pref_ans[i][j - 1] - pref_ans[i - 1][j - 1] + ans[i][j];
			pref_ans_2[i][j] = pref_ans_2[i - 1][j] + pref_ans_2[i][j - 1] - pref_ans_2[i - 1][j - 1] + pref_ans[i][j];
		}
	}

	for (ll i = 1; i <= h; i++) {
		for (ll j = 1; j <= 2; j++) {
			ans[i][j] = i * j;
			pref_ans[i][j] = pref_ans[i - 1][j] + pref_ans[i][j - 1] - pref_ans[i - 1][j - 1] + ans[i][j];
			pref_ans_2[i][j] = pref_ans_2[i - 1][j] + pref_ans_2[i][j - 1] - pref_ans_2[i - 1][j - 1] + pref_ans[i][j];
		}
	}

	for (ll i = 3; i <= h; i++) {
		for (ll j = 3; j <= w; j++) {
			ans[i][j] = qv[i][j] * i * j + pref_ans_2[i - 2][j - 2];
			pref_ans[i][j] = pref_ans[i - 1][j] + pref_ans[i][j - 1] - pref_ans[i - 1][j - 1] + ans[i][j];
			pref_ans_2[i][j] = pref_ans_2[i - 1][j] + pref_ans_2[i][j - 1] - pref_ans_2[i - 1][j - 1] + pref_ans[i][j];
		}
	}
	cout << ans[h][w].ans;
}