#include <bits/stdc++.h>

using namespace std;

/*
#define int long long

const int kek = 1e9 + 1;
const int mod = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int h, w;
    cin >> h >> w;
    vector<vector<int>> dp(h + 1, vector<int>(w + 1)), dppref(h + 1, vector<int>(w + 1)), prefdp(h + 1, vector<int>(w + 1));
    vector<vector<int>> cnt(h + 1, vector<int>(w + 1)), cntpref(h + 1, vector<int>(w + 1)), prefcnt(h + 1, vector<int>(w + 1));
    for (int i = 1; i <= h; ++i) {
        for (int j = 1; j <= w; ++j) {
            if (j == 1) {
                dp[i][j] = i * j;
                cnt[i][j] = 1;
                prefdp[i][j] = i * j;
                dppref[i][j] = 0;

                continue;
            }
            if (i == 1) {
                dp[i][j] = i * j;
                cnt[i][j] = 1;
                prefdp[i][j] = prefdp[i][j - 1] + i * j;
                dppref[i][j] = dppref[i][j - 1] + (j - 3 >= 0 ? prefdp[i][j - 3] : 0) + (j - 2 >= 0 ? dp[i][j - 2] : 0);
                continue;
            }
            ++cnt[i][j];
            for (int k = 1; k <= i - 2; ++k) {
                dp[i][j] += ((i - 1 - k) * dppref[k][j]) % mod;
                dp[i][j] %= mod;
            }
            for (int k = 1; k <= i - 2; ++k) {
                for (int p = 1; p <= j - 2; ++p) {
                    cnt[i][j] += (cnt[k][p] * (i - 1 - k) * (j - 1 - p)) % mod;
                    cnt[i][j] %= mod;
                }
            }
            dp[i][j] += i * j * cnt[i][j];
            prefdp[i][j] = prefdp[i][j - 1] + dp[i][j];
            prefdp[i][j] %= mod;
            dppref[i][j] = dppref[i][j - 1] + (j - 3 >= 0 ? prefdp[i][j - 3] : 0) + (j - 2 >= 0 ? dp[i][j - 2] : 0);
            dppref[i][j] %= mod;
        }
    }
    cout << dp[h][w] << endl;
}
*/

pair <int, int> delta[4] = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};

const int maxn = 1e3 + 7;
char path[maxn][maxn];

char a[maxn][maxn];
int dist[maxn][maxn];
pair <int, int> par[maxn][maxn];
int color[maxn][maxn];

int n, m;

int bfs(int stx, int sty, int fx, int fy) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            par[i][j] = make_pair(-1, -1);
            dist[i][j] = 1e9;
        }
    }
    dist[stx][sty] = 0;
    queue <pair <int, int>> q;
    q.push({stx, sty});
    while (q.size()) {
        int vx = q.front().first;
        int vy = q.front().second;
        if (vx == fx && vy == fy)
            break;
        q.pop();
        for (int d = 0; d < 4; d++) {
            int nx = vx + delta[d].first;
            int ny = vy + delta[d].second;
            if (nx >= 0 && ny >= 0 && nx < n && ny < m && a[nx][ny] == '#') {
                if (dist[nx][ny] > dist[vx][vy] + 1) {
                    dist[nx][ny] = dist[vx][vy] + 1;
                    par[nx][ny] = {vx, vy};
                    q.push({nx, ny});
                }
            }
        }
    }
    int res = dist[fx][fy];
    while (fx != -1 && fy != -1) {
        path[fx][fy] = '#';
        auto t = par[fx][fy];
        fx = t.first, fy = t.second;
    }
    return res;
}

void paint(int x, int y) {
    queue <pair <int, int>> q;
    q.push({x, y});
    while (q.size()) {
        int vx = q.front().first;
        int vy = q.front().second;
        q.pop();
        for (int d = 0; d < 4; d++) {
            int nx = vx + delta[d].first;
            int ny = vy + delta[d].second;
            if (nx >= 0 && ny >= 0 && nx < n && ny < m && a[nx][ny] == '.') {
                if (color[nx][ny] == -1) {
                    color[nx][ny] = color[vx][vy];
                    q.push({nx, ny});
                }
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            path[i][j] = '.';
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            color[i][j] = -1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '#')
                color[i][j] = 1;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (color[i][j] == -1 && (i == 0 || j == 0 || j == m - 1 || i == n - 1)) {
                color[i][j] = 0;
                paint(i, j);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            if (color[i][j] == -1)
                color[i][j] = 2;
    }
    int max_x = -1, min_x = 1e9, max_y = -1, min_y = 1e9;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (color[i][j] != 2)
                continue;
            max_x = max(max_x, i);
            min_x = min(min_x, i);
            max_y = max(max_y, j);
            min_y = min(min_y, j);
        }
    }

    int minl = 1e9, maxl = -1e9;
    int minu = 1e9, maxu = -1e9;
    int minr = 1e9, maxr = -1e9;
    int mind = 1e9, maxd = -1e9;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (color[i][j] == 2) {
                if (i == min_x)
                    minu = min(minu, j), maxu = max(maxu, j);
                if (i == max_x)
                    mind = min(mind, j), maxd = max(maxd, j);
                if (j == min_y)
                    minl = min(minl, i), maxl = max(maxl, i);
                if (j == max_y)
                    minr = min(minr, i), maxr = max(maxr, i);
            }
        }
    }
    bfs(min_x - 1, minu, min_x - 1, maxu);
    bfs(min_x - 1, maxu, minr, max_y + 1);
    bfs(minr, max_y + 1, maxr, max_y + 1);
    bfs(maxr, max_y + 1, max_x + 1, maxd);
    bfs(max_x + 1, maxd, max_x + 1, mind);
    bfs(max_x + 1, mind, maxl, min_y - 1);
    bfs(maxl, min_y - 1, minl, min_y - 1);
    bfs(minl, min_y - 1, min_x - 1, minu);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            cout << path[i][j];
        cout << "\n";
    }
}
