#include <bits/stdc++.h>

using namespace std;
#define all(a) (a).begin(), (a).end()

typedef long long ll;
#define f(i, l, r) for(int i = l; i < r; i++)
#define int ll
#define pb push_back
const int INF = 1e18;

/*
struct node {
    int len, m, m2;
    node() = default;
    node(int len_, int m_, int m2_) {
        len=len_;
        m=m_;
        m2=m2_;
    }
};

node operator+(node a, node b) {

    vector<int> nw = {a.m,a.m2,b.m,b.m2};
    sort(all(nw));
    return node(a.len + b.len, nw[3], nw[2]);
}

struct segtree {
    int n;
    vector<int> a;
    vector<node> t;
    segtree() = default;
    segtree(int n_, vector<int> a_) {
        n = n_;
        a = a_;
        t.resize(4 * n);
        build(1, 0, n);
    }

    void build(int v, int tl, int tr) {
        if (tl + 1 == tr) {
            t[v] = node(1, a[tl], -1);
            return;
        }

        int tm = (tl + tr) / 2;
        build(v*2,tl,tm);build(v*2+1,tm, tr);t[v]=t[v*2]+t[v*2+1];
    }

    node req(int v, int tl, int tr, int l, int r) {
        if (l <= tl && tr <= r) return t[v];
        if (tr <= l || tl >= r) return node(0, -1, -1);

        int tm = (tl + tr) / 2;
        return req(v*2,tl,tm,l,r)+req(v*2+1,tm,tr,l,r);
    }
};
 */

vector<int> dijkstra(int n, vector<vector<pair<int, int>>> &g, int s) {
    vector<int> dist(n, INF);
    vector<int> used(n, 0);
    dist[s] = 0;
    set<pair<int, int>> D;
    f (i, 0, n) D.insert({dist[i], i});
    while(!D.empty()) {
        auto it = D.begin();
        auto pr = *it;
        used[pr.second] = 1;
        D.erase(pr);

        for (auto &[u, w] : g[pr.second]) {
            if (!used[u] && dist[u] > dist[pr.second] + w) {
                D.erase({dist[u], u});
                D.insert({dist[pr.second] + w, u});
                dist[u] = dist[pr.second] + w;
            }
        }
    }

    return dist;
}

vector<vector<int>> dij_g, dgrev;
vector<int> cnt, used, cnt2;
int F;

void dfs(int v) {
    if (v==F)cnt[v]=1;
    used[v] = 1;
    for (auto &u : dij_g[v]) {
        if (!used[u]) {
            dfs(u);
        }
        cnt[v]+=cnt[u];
        cnt[v] %= 1000000007;
    }
}

void dfs2(int v) {
    used[v] = 1;
    for (auto &u : dgrev[v]) {
        if (!used[u]) {
            dfs2(u);
        }
        cnt2[v] += cnt2[u];
        cnt2[v] %= 1000000007;
    }

}


signed main() {
    ios_base::sync_with_stdio(false);


    int n, m; cin >> n >> m;
    int s, f, l; cin >> s >> f >> l;
    s--;f--;
    F=f;
    vector<vector<pair<int,int>>> g(n);
    vector<vector<int>> edg;

    f(i,0,m){
        int e,r,w;cin>>e>>r>>w;
        e--;r--;
        g[e].pb({r,w});
        edg.pb({e, r, w});
        g[r].pb({e,w});
    }

    vector<int> ks = dijkstra(n, g, s), kf = dijkstra(n,g,f);
    if (ks[f] > l) {
        cout<<"0\n";
        return 0;
    }
    dij_g.assign(n, {});
    cnt.assign(n, 0);
    cnt2.assign(n, 0);
    dgrev.assign(n, {});

    used.assign(n, 0);

    for (auto &u : edg) {
        //cout << kf[u[0]] << ' ' << kf[u[1]] << ' ' << u[0] << ' ' << u[1] << ' ' << u[2] << '\n';
        if (kf[u[0]] + u[2] == kf[u[1]]) {
            dij_g[u[1]].pb(u[0]);
        } else if (kf[u[1]] + u[2] == kf[u[0]]) {
            dij_g[u[0]].pb(u[1]);
        }

        if (ks[u[0]] + u[2] == ks[u[1]]) {
            //cout << u[0] << ' ' << u[1] << '\n';
            dgrev[u[1]].pb(u[0]);
        } else if (ks[u[1]] + u[2] == ks[u[0]]) {
            //cout << u[1] << ' ' << u[0] << '\n';
            dgrev[u[0]].pb(u[1]);
        }
    }

    f (i, 0, n ) {
        if (!used[i]) dfs(i);
    }
    used.assign(n, 0);
    cnt2[s] = 1;
    f (i, 0, n ) {
        if (!used[i]) dfs2(i);
    }

    if (ks[f] == l) {
        cout << cnt[s] << '\n';
        return 0;
    }
    int ans = 0;

    f (i, 0, n) {
        if (ks[i] + kf[i] == ks[f]) {
            // on route
            //cout<<i<<'\n';
            for (auto &u : g[i]) {
                if (ks[i] + u.second + kf[u.first] == l) {
                    //cout<< cnt[u.first] * cnt2[i]<<' '<<u.first<<' '<<i<<'\n';
                    ans += (cnt[u.first] * cnt2[i]) % 1000000007;
                    ans %= 1000000007;
                }
            }
        }
    }

    cout<<ans<<'\n';
}
