#include <bits/stdc++.h>
#pragma GCC optimize("O3,no-stack-protector")

using namespace std;

const vector<int> dx = {-1, 0, 1, 0};
const vector<int> dy = {0, -1, 0, 1};
const int maxw = 1057;

char f[maxw][maxw];

bool water[maxw][maxw];

int n, m;
void dfs(int i, int j) {
    if (!water[i][j]) return;
    water[i][j] = false;
    for (int d = 0; d < 4; ++d) {
        int di = i + dx[d], dj = j + dy[d];
        if (di < 0 || di >= n || dj < 0 || dj >= m || !water[di][dj]) continue;
        dfs(di, dj);
    }
}

const int inf = 1e9 + 1329;

int dist[maxw][maxw];
pair<int, int> p[maxw][maxw];
char ans[maxw][maxw];

signed main() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> f[i][j];
            water[i][j] = (f[i][j] == '.');
            p[i][j] = make_pair(i, j);
            dist[i][j] = inf;
            ans[i][j] = '.';
        }
    }
    for (int i = 0; i < n; ++i) {
        dfs(i, 0);
        dfs(i, m - 1);
    }
    for (int j = 0; j < m; ++j) {
        dfs(0, j);
        dfs(n - 1, j);
    }
    int minx = n;
    int minxy = -1;
    bool broke = false;
    for (int i = 0; i < n && !broke; ++i) {
        for (int j = 0; j < m; ++j) {
            if (water[i][j]) {
                minx = i;
                minxy = j;
                broke = true;
                break;
            }
        }
    }
    for (int i = 0; i <= minx - 1; ++i) {
        f[i][minxy] = '.';
    }
    pair<int, int> s = {minx - 1, minxy - 1};
    pair<int, int> t = {minx - 1, minxy + 1};
//    cout << s.first << ' ' << s.second << '\n' << t.first << ' ' << t.second << '\n';
//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < m; ++j) {
//            cout << f[i][j];
//        } cout << '\n';
//    }
    queue<pair<int, int>> q;
    q.push(s);
    dist[s.first][s.second] = 0;
    while (!q.empty()) {
        pair<int, int> v = q.front();
        q.pop();
        //cerr << v.first << ' ' << v.second << ' ' << dist[v.first][v.second] << '\n';
        if (v == t) break;
        for (int d = 0; d < 4; ++d) {
            pair<int, int> u = {v.first + dx[d], v.second + dy[d]};
            if (u.first < 0 || u.first >= n || u.second < 0 || u.second >= m) continue;
            if (f[u.first][u.second] != '#') continue;
            if (dist[u.first][u.second] > dist[v.first][v.second] + 1) {
                dist[u.first][u.second] = dist[v.first][v.second] + 1;
                p[u.first][u.second] = v;
                q.push(u);
            }
        }
    }
    while (t != s) {
        ans[t.first][t.second] = '#';
        t = p[t.first][t.second];
    }
    ans[s.first][s.second] = '#';
    ans[minx - 1][minxy] = '#';
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << ans[i][j];
        } cout << '\n';
    }
}