#include <bits/stdc++.h>

using namespace std;

using Triangle = array<int, 3>;

bool Tetrahedron(Triangle T1, Triangle T2, Triangle T3, Triangle T4) {
    array<Triangle, 4> ts{};
    ts[0] = T1;
    ts[1] = T2;
    ts[2] = T3;
    ts[3] = T4;
    array<array<int, 3>, 6> perms{};
    perms[0] = {1,2,3};
    perms[1] = {1,3,2};
    perms[2] = {2,1,3};
    perms[3] = {2,3,1};
    perms[4] = {3,1,2};
    perms[5] = {3,2,1};
    for (auto perm: perms) {
        bool ok = true;
        array<int, 3> good_pos{};
        for (int i = 0; i < 3; ++i) {
            good_pos[i] =  find(ts[perm[i]].begin(), ts[perm[i]].end(), T1[i]) - ts[perm[i]].begin();
            if (good_pos[i] == 3) {
                ok = false;
                break;
            }
        }
        if (!ok) {
            continue;
        }
        array<int, 3> mark{};
        for (int p1 = 0; p1 < 3; ++p1) {
            if (p1 == good_pos[0]) {
                continue;
            }
            int p2 = -1;
            for (int x = 0; x < 3; ++x) {
                if (x == good_pos[2]) {
                    continue;
                }
                if (ts[perm[2]][x] == ts[perm[0]][p1]) {
                    p2 = x;
                    break;
                }
            }
            if (p2 == -1) {
                continue;
            }
            mark[0] = p1;
            mark[2] = p2;
            int p12 = 3 - mark[0] - good_pos[0];
            int p32 = 3 - mark[2] - good_pos[2];
            array<int, 2> ind{};
            if (good_pos[1] == 0) {
                ind[0] = 1;
                ind[1] = 2;
            } else if (good_pos[1] == 1) {
                ind[0] = 0;
                ind[1] = 2;
            } else {
                ind[0] = 0;
                ind[1] = 1;
            }
            if (ts[perm[1]][ind[0]] == ts[perm[0]][p12] && ts[perm[1]][ind[1]] == ts[perm[2]][p32]) {
                return true;
            }
            if (ts[perm[1]][ind[0]] == ts[perm[2]][p32] && ts[perm[1]][ind[1]] == ts[perm[0]][p12]) {
                return true;
            }
        }
    }
    return false;
}

int main() {
    int n;
    cin >> n;
    vector<Triangle> a(n);
    for (Triangle &x : a) {
        cin >> x[0] >> x[1] >> x[2];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                for (int l = k + 1; l < n; ++l) {
                    if (Tetrahedron(a[i], a[j], a[k], a[l])) {
                        cout << "Yes\n";
                        cout << i +1 << " " << j+1 << " " << k+1 << " " << l+1 << "\n";
                        return;
                    }
                }
            }
        }
    }
    cout<<"No\n";
}
