#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <ctime>
#include <cassert>
#include <chrono>
#include <vector>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

struct edge
{
	long long to, w;
};

long long n;
vector<edge> g[200000];
vector<long long> ga[200000], gb[200000], rga[200000], rgb[200000];
vector<long long> dsta, dstb, waya, wayb;

void swdag()
{
	swap(ga, gb);
	swap(rga, rgb);
	swap(dsta, dstb);
	swap(waya, wayb);
}

void dijkstra(long long fr, long long nd)
{
	vector<long long> dist(n, INF);
	dist[fr] = 0;
	set<pair<long long, long long>> q;
	q.insert({ 0, fr });
	while (q.size())
	{
		auto [dst, ver] = *q.begin();
		q.erase(q.begin());
		for (auto& i : g[ver])
		{
			if (dist[i.to] > dst + i.w)
			{
				q.erase({ dist[i.to], i.to });
				dist[i.to] = dst + i.w;
				q.insert({ dist[i.to], i.to });
			}
		}
	}
	dsta = dist;

	if (nd == -1)
	{
		for (long long i = 0; i < n; i++)
		{
			for (auto& j : g[i])
			{
				if (dist[j.to] == dist[i] + j.w)
				{
					ga[i].push_back(j.to);
					rga[j.to].push_back(i);
				}
			}
		}
	}
	else
	{
		deque<long long> qq = { nd };
		vector<bool> used(n);
		while (qq.size())
		{
			long long ver = qq.front();
			qq.pop_front();
			used[ver] = true;
			for (auto& i : g[ver])
			{
				if (dist[i.to] + i.w == dist[ver])
				{
					ga[i.to].push_back(ver);
					rga[ver].push_back(i.to);
					if (!used[i.to])
					{
						qq.push_back(i.to);
						used[i.to] = true;
					}
				}
			}
		}
	}
}

void cntway(long long v)
{
	if (waya[v] != -1)
	{
		return;
	}

	long long sum = 0;
	for (auto& i : rga[v])
	{
		cntway(i);
		sum += waya[i];
		sum %= MOD;
	}
	waya[v] = sum;
}

void solve()
{
	long long m, a, b, l;
	cin >> n >> m;
	waya.resize(n, -1);
	wayb.resize(n, -1);
	cin >> a >> b >> l;
	a--; b--;
	for (long long i = 0; i < m; i++)
	{
		long long a, b, c;
		cin >> a >> b >> c;
		a--; b--;
		g[a].push_back({ b, c });
		g[b].push_back({ a, c });
	}

	dijkstra(a, b);
	swdag();
	dijkstra(b, -1);
	swdag();

	waya[a] = 1;
	wayb[b] = 1;
	for (long long i = 0; i < n; i++)
	{
		cntway(i);
	}
	swdag();
	for (long long i = 0; i < n; i++)
	{
		cntway(i);
	}
	swdag();

	if (l == dsta[b] && false)
	{
		cout << waya[b] << "\n";
	}
	else
	{
		long long ans = 0;
		for (long long i = 0; i < n; i++)
		{
			for (auto& j : g[i])
			{
				if (dsta[i] + j.w + dstb[j.to] != l)
				{
					continue;
				}

				ans += (waya[i] * wayb[i]) % MOD;
				ans %= MOD;
			}
		}
		cout << ans << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*



















*/
