#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define  vec vector
#define int long long
#define all(a) a.begin(), a.end()

typedef vector<int> vi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vi> vvi;
typedef vector<bool> vb;

template<typename T> void input(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}

const int MAXN = 410, MOD = 1e9 + 7;
/*
int dp[MAXN][MAXN];
int cnt[MAXN][MAXN];
int pdij[MAXN][MAXN], pdi[MAXN][MAXN], pdj[MAXN][MAXN], pd[MAXN][MAXN];
int pcij[MAXN][MAXN], pci[MAXN][MAXN], pcj[MAXN][MAXN], pc[MAXN][MAXN];
*/
vvi dp(MAXN, vi(MAXN, 0));
vvi cnt(MAXN, vi(MAXN, 0));
vvi pdij(MAXN, vi(MAXN, 0));
vvi pdi(MAXN, vi(MAXN, 0));
vvi pdj(MAXN, vi(MAXN, 0));
vvi pd(MAXN, vi(MAXN, 0));
vvi pcij(MAXN, vi(MAXN, 0));
vvi pci(MAXN, vi(MAXN, 0));
vvi pcj(MAXN, vi(MAXN, 0));
vvi pc(MAXN, vi(MAXN, 0));

void f(vvi& p, int i, int j) {
	p[i][j] = p[i - 1][j] + p[i][j - 1] - p[i - 1][j - 1];
	p[i][j] = (p[i][j] % MOD + MOD) % MOD;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int h, w;
	cin >> h >> w;
	//pdij[1][1] = pdi[1][1] = pdj[1][1] = pd[1][1] = pcij[1][1] = pci[1][1] = pcj[1][1] = pc[1][1] = dp[1][1] = cnt[1][1] = 1;
	for (int i = 1; i <= h; ++i) {
		for (int j = 1; j <= w; ++j) {
			if (i <= 2 || j <= 2) {
				dp[i][j] = j * i;
				cnt[i][j] = 1;
				f(pdij, i, j);
				f(pdi, i, j);
				f(pdj, i, j);
				f(pd, i, j);
				f(pcij, i, j);
				f(pci, i, j);
				f(pcj, i, j);
				f(pc, i, j);
				pdij[i][j] += dp[i][j] * (i + 1) * (j + 1);
				pdi[i][j] += dp[i][j] * (i + 1);
				pdj[i][j] += dp[i][j] * (j + 1);
				pd[i][j] += dp[i][j];

				pcij[i][j] += cnt[i][j] * (i + 1) * (j + 1);
				pci[i][j] += cnt[i][j] * (i + 1);
				pcj[i][j] += cnt[i][j] * (j + 1);
				pc[i][j] += cnt[i][j];

				pdij[i][j] = (pdij[i][j] % MOD + MOD) % MOD;
				pdi[i][j] = (pdi[i][j] % MOD + MOD) % MOD;
				pdj[i][j] = (pdj[i][j] % MOD + MOD) % MOD;
				pd[i][j] = (pd[i][j] % MOD + MOD) % MOD;
				pcij[i][j] = (pcij[i][j] % MOD + MOD) % MOD;
				pci[i][j] = (pci[i][j] % MOD + MOD) % MOD;
				pcj[i][j] = (pcj[i][j] % MOD + MOD) % MOD;
				pc[i][j] = (pc[i][j] % MOD + MOD) % MOD;
				continue;
			}
			f(pdij, i, j);
			f(pdi, i, j);
			f(pdj, i, j);
			f(pd, i, j);
			f(pcij, i, j);
			f(pci, i, j);
			f(pcj, i, j);
			f(pc, i, j);
			cnt[i][j] = i * j * pc[i - 2][j - 2] - i * pcj[i - 2][j - 2] - j * pci[i - 2][j - 2] + pcij[i - 2][j - 2] + 1;
			cnt[i][j] = (cnt[i][j] % MOD + MOD) % MOD;
			dp[i][j] = i * j * pd[i - 2][j - 2] - i * pdj[i - 2][j - 2] - j * pdi[i - 2][j - 2] + pdij[i - 2][j - 2];
			dp[i][j] += cnt[i][j] * i * j;
			dp[i][j] = (dp[i][j] % MOD + MOD) % MOD;
			pdij[i][j] += dp[i][j] * (i + 1) * (j + 1);
			pdi[i][j] += dp[i][j] * (i + 1);
			pdj[i][j] += dp[i][j] * (j + 1);
			pd[i][j] += dp[i][j];
			pcij[i][j] += cnt[i][j] * (i + 1) * (j + 1);
			pci[i][j] += cnt[i][j] * (i + 1);
			pcj[i][j] += cnt[i][j] * (j + 1);
			pc[i][j] += cnt[i][j];


			pdij[i][j] = (pdij[i][j] % MOD + MOD) % MOD;
			pdi[i][j] = (pdi[i][j] % MOD + MOD) % MOD;
			pdj[i][j] = (pdj[i][j] % MOD + MOD) % MOD;
			pd[i][j] = (pd[i][j] % MOD + MOD) % MOD;
			pcij[i][j] = (pcij[i][j] % MOD + MOD) % MOD;
			pci[i][j] = (pci[i][j] % MOD + MOD) % MOD;
			pcj[i][j] = (pcj[i][j] % MOD + MOD) % MOD;
			pc[i][j] = (pc[i][j] % MOD + MOD) % MOD;
		}
	}
	cout << dp[h][w];
	return 0;
}