#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
using namespace std;
vector<int> dX = { 1, 0, -1, 0 };
vector<int> dY = { 0, 1, 0, -1 };
vector<int> dX2 = { 1, 1, -1, -1 };
vector<int> dY2 = { 1, -1, 1, -1 };

vector<vector<int>> board;
vector<vector<bool>> used;
vector<vector<bool>> reach;
vector<vector<int>> gt;
void DFS(int x, int y, int H, int W) {
	used[x][y] = true;
	for (int i = 0; i < 4; ++i) {
		int new_x = x + dX[i]; int new_y = y + dY[i];
		if (new_x < 0 || new_x >= H || new_y < 0 || new_y >= W) {
			reach[x][y] = true;
			return;
		}
	}
	for (int i = 0; i < 4; ++i) {
		int new_x = x + dX[i]; int new_y = y + dY[i];
		if (board[new_x][new_y] == 0) continue;
		if (!used[new_x][new_y]) DFS(new_x, new_y, H, W);
		if (reach[new_x][new_y]) {
			reach[x][y] = true;
			return;
		}
	}
}
void solve() {
	int H = 0, W = 0; cin >> H >> W;
	board.assign(H, vector<int>(W, 0));
	used.assign(H, vector<bool>(W, false));
	for (int i = 0; i < H; ++i) {
		string s1 = ""; cin >> s1;
		for (int j = 0; j < W; ++j) {
			if (s1[j] == '.') board[i][j] = 1;
		}
	}
	reach.assign(H, vector<bool>(W, false));
	for (int i = 0; i < H; ++i) {
		for (int j = 0; j < W; ++j) {
			if (!used[i][j] && board[i][j] == 1) DFS(i, j, H, W);
		}
	}
	gt.assign(H, vector<int>(W, -1));
	for (int i = 0; i < H; ++i) {
		for (int j = 0; j < W; ++j) {
			if (board[i][j] == 0) continue;
			if (reach[i][j]) continue;
			for (int k = 0; k < 4; ++k) {
				int new_x = i + dX[k]; int new_y = j + dY[k];
				if (board[new_x][new_y] == 0) gt[new_x][new_y] = 1;
			}
		}
	}
	for(int i = 0; i < H; ++i) {
		for (int j = 0; j < W; ++j) {
			if (gt[i][j] != 1) continue;
			for (int k = 0; k < 4; ++k) {
				int new_x = i + dX2[k]; int new_y = j + dY2[k];
				if (new_x < 0 || new_x >= H || new_y < 0 || new_y >= W) continue;
				if (gt[new_x][new_y] != 1) continue;
				if (board[i][new_y] == 0) gt[i][new_y] = 2;
				else gt[new_x][j] = 2;
			}
		}
	}
	vector<vector<int>> deg;
	vector<vector<bool>> aldel;
	aldel.assign(H, vector<bool>(W, false));
	deg.assign(H, vector<int>(W, 0));
	for (int i = 0; i < H; ++i) {
		for (int j = 0; j < W; ++j) {
			if (gt[i][j] <= 0) continue;
			for (int k = 0; k < 4; ++k) {
				int new_x = i + dX[k]; int new_y = j + dY[k];
				if (new_x < 0 || new_x >= H || new_y < 0 || new_y >= W) continue;
				if (gt[new_x][new_y] > 0) deg[new_x][new_y]++;
			}
		}
	}
	vector<pair<int, int>> todel;
	for (int i = 0; i < H; ++i) {
		for (int j = 0; j < W; ++j) {
			if (gt[i][j] > 0 && deg[i][j] == 1) todel.push_back({ i, j });
		}
	}
	while (!todel.empty()) {
		auto p1 = todel.back(); todel.pop_back();
		if (aldel[p1.first][p1.second]) continue;
		gt[p1.first][p1.second] = 0;
		aldel[p1.first][p1.second] = true;
		for (int k = 0; k < 4; ++k) {
			int new_x = p1.first + dX[k]; int new_y = p1.second + dY[k];
			if (new_x < 0 || new_x >= H || new_y < 0 || new_y >= W) continue;
			if (gt[new_x][new_y] > 0) {
				deg[new_x][new_y]--;
				if (deg[new_x][new_y] == 1 && !aldel[new_x][new_y]) todel.push_back({ new_x, new_y });
			}
		}
	}
	for (int i = 0; i < H; ++i) {
		for (int j = 0; j < W; ++j) {
			if (gt[i][j] > 0) cout << "#";
			else cout << ".";
		}
		cout << "\n";
	}
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	cout << setprecision(20);
	solve();
	return 0;
}