#include<bits/stdc++.h>

using namespace std;

typedef long double ld;
using ll = long long;
#define int ll

const int INF = 1e9 + 42;
const int MOD = 1e9 + 7;

template<class T>
struct Mint {
    T val;
    Mint() : val(0) {}
    Mint(T val) : val(val) {}

    Mint operator+(const Mint& a) const {
        return Mint((val + a.val) % MOD);
    }

    void operator+=(const Mint& a) {
        *this = (*this) + a;
    }

    Mint operator-(const Mint& a) const {
        return Mint((val - a.val + MOD) % MOD);
    }

    void operator-=(const Mint& a) {
        *this = (*this) - a;
    }

    Mint operator*(const Mint& a) const {
        return Mint(val * a.val % MOD);
    }

    void operator*=(const Mint& a) {
        *this = (*this) * a;
    }
};

template<class T>
ostream& operator<<(ostream& out, const Mint<T>& a) {
    out << a.val;
    return out;
}

using mint = Mint<ll>;

signed main() {
    int H, W;
    cin >> H >> W;

    vector<vector<mint>> cnt(H + 1, vector<mint>(W + 1));
    vector<vector<mint>> prc(H + 1, vector<mint>(W + 1));
    for (int h = 1; h <= H; ++h)
        for (int w = 1; w <= W; ++w) {//cout << h  << " " << w << endl;
            if (h <= 2 || w <= 2)
                cnt[h][w] = 1;
            else {
                cnt[h][w] = cnt[h - 1][w];
                for (int ww = 0; ww < w; ++ww) {
                    cnt[h][w] += prc[h - 2][ww] * (w - ww - 1);
                }
            }
            if (h > 0)
                prc[h][w] = prc[h - 1][w] + cnt[h][w];
        }
/*
    for (auto i : cnt) {
        for (auto j : i)
            cout << j << " ";
        cout << endl;
    }
    cout << endl;
*/
    vector<vector<mint>> dp(H + 1, vector<mint>(W + 1));
    vector<vector<mint>> prd(H + 1, vector<mint>(W + 1));
    for (int h = 0; h <= H; ++h)
        for (int w = 0; w <= W; ++w) {
            if (h <= 2 || w <= 2)
                dp[h][w] = mint(h * w);
            else {
                dp[h][w] = dp[h - 1][w] + cnt[h][w] * h * w - cnt[h - 1][w] * (h - 1) * w;
                for (int ww = 0; ww < w; ++ww)
                    dp[h][w] += prd[h - 2][ww] * (w - ww - 1);
            }
            if (h > 0)
                prd[h][w] = prd[h - 1][w] + dp[h][w];
        }
/*
    for (auto& i : dp) {
        for (auto j : i)
            cout << j << " ";
        cout << endl;
    }*/

    cout << dp[H][W].val << endl;
}
