#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;
#define all(a) a.begin(), a.end()
#define int long long
#define st string
#define pb push_back
#define vec vector
#define pi pair<int, int>
#define ff first
#define ss second
#define vpi vector<pair<int, int>>
using namespace std;
#define all(a) a.begin(), a.end()
#define int long long
template <typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (size_t i = 0; i < v.size(); ++i) cin >> v[i];
    return in;
}
const int mod = 1000000007LL, inf = 2e17 + 1;
int n, m, s, t, L;
vector<vector<pair<int, int>>> g, dag, gr;
set<pair<int, int>> in;
vector<int> used, top;

void dejkstra(int st, vector<int>& d) {
    d[st] = 0;
    set<pair<int, int>> q;
    for (int i = 0; i < n; ++i) {
        q.emplace(d[i], i);
    }
    used.assign(n, 0);
    while (!q.empty()) {
        auto [dist, v] = (*q.begin());
        used[v] = true;
        q.erase(q.begin());
        if (dist == inf) continue;
        for (auto [u, c] : g[v]) {
            if (used[u]) continue;
            q.erase({ d[u], u });
            d[u] = min(d[u], d[v] + c);
            q.insert({ d[u], u });
        }
    }
}

void dfs(int v, vector<int>& d) {
    used[v] = true;
    for (auto [u, c] : g[v]) {
        if (d[u] == d[v] - c) {
            dag[v].emplace_back(u, c);
            in.emplace(v, u);
            if (!used[u]) dfs(u, d);
        }
    }
    top.push_back(v);
}

void dfs2(int v, vector<int>& d) {
    used[v] = true;
    for (auto [u, c] : g[v]) {
        if (d[u] - c == d[v]) {
            gr[u].emplace_back(v, c);
            if (!used[u]) dfs2(u, d);
        }
    }
    top.push_back(v);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> m >> s >> t >> L;
    --s, --t;
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    vector<int> dt, ds;
    dt.assign(n, inf);
    ds.assign(n, inf);
    dejkstra(t, dt);
    dejkstra(s, ds);
    dag.resize(n);
    gr.resize(n);
    used.assign(n, 0);
    dfs2(t, dt);
    vector<int> cnts(n, 0), cntt(n, 0);
    cntt[t] = 1;
    reverse(all(top));
    for (auto i : top) {
        for (auto [u, c] : gr[i]) {
            cntt[i] += cntt[u];
            cntt[i] %= mod;
        }
    }
    used.assign(n, 0);
    top = {};
    dfs(s, dt);
    reverse(all(top));
    cnts[s] = 1;
    for (auto i: top) {
        for (auto [u, c] : dag[i]) {
            cnts[u] += cnts[i];
            cnts[u] %= mod;
        }
    }
    reverse(all(top));
    int len = dt[s];
    int ans = (len == L ? cnts[t] : 0);
    for (int v = 0; v < n; ++v) {
        if (v == t || !used[v]) continue;
        for (auto [u, c] : g[v]) {
            if (in.count({ v, u }) > 0) continue;
            if (ds[v] + dt[u] + c == L) {
                ans += (cnts[v] % mod) * (cntt[u] % mod);
            }
            ans %= mod;
        }
    }
    cout << ans;
}