#include <bits/stdc++.h>

using namespace std;
#define ll long long
const int MAXN = 1000;
const int INF = 1e9;
int n, m;

string a[MAXN];
int used[MAXN][MAXN];

int dx[4] = {-1, 1, 0, 0};
int dy[4] = {0, 0, -1, 1};

pair <int, int> get_flex(int x, int y) {
    vector <pair <int, int>> all;
    vector <pair <int, int>> st;
    st.emplace_back(x, y);
    all.emplace_back(x, y);
    used[x][y] = 1;
    while (!st.empty()) {
        int xx = st.back().first;
        int yy = st.back().second;
        st.pop_back();
        for (int k = 0; k < 4; ++k) {
            int xxx = xx + dx[k];
            int yyy = yy + dy[k];
            if (xxx < 0 || xxx >= n || yyy < 0 || yyy >= m || used[xxx][yyy] || a[xxx][yyy] != '.') continue;
            all.emplace_back(xxx, yyy);
            st.emplace_back(xxx, yyy);
            used[xxx][yyy] = 1;
        }
    }
    bool bad = false;
    for (auto i : all) {
        if (i.first == 0 || i.first == n - 1 || i.second == 0 || i.second == m - 1) bad = true;
    }
    if (bad) return {-1, -1};
    int mn = n;
    for (auto i : all) {
        mn = min(mn, i.first);
    }
    int mny = m;
    for (auto i : all) {
        if (i.first == mn) mny = min(mny, i.second);
    }
    return make_pair(mn, mny);
}

void find_ans(int x, int y) {
    vector <vector <int>> d(n, vector <int> (m, INF));
    vector <vector <pair <int, int>>> pr(n, vector <pair <int, int>> (m, make_pair(-1, -1)));
    queue <pair <int, int>> q;

    auto ok = [&](int x1, int y1, int x2, int y2) {
        if (x1 != x2) return true;
        if (min(x1, x2) > x) return true;
        if (min(y1, y2) == y) return false;
        return true;
    };

    q.push(make_pair(x, y + 1));
    d[x][y + 1] = 0;
    while (!q.empty()) {
        int xx = q.front().first;
        int yy = q.front().second;
        q.pop();
        for (int k = 0; k < 4; ++k) {
            int xxx = xx + dx[k];
            int yyy = yy + dy[k];
            if (xxx < 0 || xxx >= n || yyy < 0 || yyy >= m || a[xxx][yyy] != '#' || !ok(xx, yy, xxx, yyy)) continue;
            if (d[xxx][yyy] > d[xx][yy] + 1) {
                d[xxx][yyy] = d[xx][yy] + 1;
                pr[xxx][yyy] = make_pair(xx, yy);
                q.push(make_pair(xxx, yyy));
            }
        }
    }
    vector <vector <int>> ans(n, vector <int> (m));
    int xx = x, yy = y;
    while (xx != -1) {
        ans[xx][yy] = 1;
        int new_x = pr[xx][yy].first;
        int new_y = pr[xx][yy].second;
        xx = new_x;
        yy = new_y;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (ans[i][j]) cout << "#";
            else cout << ".";
        }
        cout << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (used[i][j] || a[i][j] == '#') continue;
            pair <int, int> xd = get_flex(i, j);
            if (xd.first == -1) continue;
            find_ans(xd.first - 1, xd.second - 1);
            return 0;
        }
    }
    return 0;
}

/*
3 10 5
0 3
1 1
4 2
 */