#include <bits/stdc++.h>

using namespace std;
#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
const int INF = 1e9 + 7;
const vector<pii> shift = {
        {-1, 0},
        {1,  0},
        {0,  -1},
        {0,  1}
};
vector<string> ar;
vector<vi> col;
vector<bool> good;

int n, m;

bool in_bound(int i, int j) {
    return (i >= 0 && i < n && j >= 0 && j < m);
}

void dfs(int i, int j, int c) {
    col[i][j] = c;
    if (i == 0 || i == n - 1 || j == 0 || j == m - 1) good[c] = false;
    for (auto [di, dj]: shift) {
        if (in_bound(i + di, j + dj) && ar[i + di][j + dj] == '.' && col[i + di][j + dj] == -1) {
            dfs(i + di, j + dj, c);
        }
    }
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);
    cout << fixed << setprecision(15);
    cin >> n >> m;
    ar.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> ar[i];
    }
    col.resize(n, vi(m, -1));
    int c = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (ar[i][j] == '.' && col[i][j] == -1) {
                good.emplace_back(true);
                dfs(i, j, c++);
            }
        }
    }
    int comp = -1;
    for (int i = 0; i < c; ++i) {
        if (good[i]) {
            comp = i;
        }
    }
    assert(comp != -1);
    int u_i = -1, u_j = -1, d_i = -1, d_j = -1;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (col[i][j] == comp) {
                if (u_i == -1 || i < u_i) {
                    u_i = i, u_j = j;
                }
                if (d_i == -1 || i > d_i) {
                    d_i = i, d_j = j;
                }
            }
        }
    }
    assert(d_i != -1 && u_i != -1);
    pii st(u_i - 1, u_j);
    pii tg(d_i + 1, d_j);
    vector<vi> dist(n, vi(m, INF));
    vector<vector<pii>> par(n, vector<pii>(m, {-1, -1}));
    vector<pii> q{st};
    dist[st.first][st.second] = 0;
    for (int iter = 0; iter < sz(q); ++iter) {
        auto [i, j] = q[iter];
        for (auto [di, dj]: shift) {
            if (in_bound(i + di, j + dj)) {
                if (ar[i + di][j + dj] != '#') continue;
                if (dist[i + di][j + dj] > dist[i][j] + 1) {
                    dist[i + di][j + dj] = dist[i][j] + 1;
                    par[i + di][j + dj] = {i, j};
                    q.emplace_back(i + di, j + dj);
                }
            }
        }
    }
    for (int i = st.first - 1; i >= 0; --i) {
        ar[i][st.second] = '.';
    }
    for (int i = tg.first + 1; i < n; ++i) {
        ar[i][tg.second] = '.';
    }
    auto tmp = par[tg.first][tg.second];
    ar[tmp.first][tmp.second] = '.';
    vector<string> output(n, string(m, '.'));
    output[st.first][st.second] = '#';
    for (auto cur = tg; cur != st; cur = par[cur.first][cur.second]) {
        output[cur.first][cur.second] = '#';
    }
    dist.assign(n, vi(m, INF));
    par.assign(n, vector<pii>(m, make_pair(-1, -1)));
    dist[st.first][st.second] = 0;
    for (int iter = 0; iter < sz(q); ++iter) {
        auto [i, j] = q[iter];
        for (auto [di, dj]: shift) {
            if (i + di >= 0 && i + di < n && j + dj >= 0 && j + dj < m) {
                if (ar[i + di][j + dj] != '#') continue;
                if (dist[i + di][j + dj] > dist[i][j] + 1) {
                    dist[i + di][j + dj] = dist[i][j] + 1;
                    par[i + di][j + dj] = {i, j};
                    q.emplace_back(i + di, j + dj);

                }
            }
        }
    }
    for (auto cur = tg; cur != st; cur = par[cur.first][cur.second]) {
        output[cur.first][cur.second] = '#';
    }
    for (auto el: output) {
        cout << el << '\n';
    }
}
