#include <bits/stdc++.h>

using namespace std;
#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

using u32 = uint32_t;

struct Montgomery {
    u32 n, nr;

    constexpr explicit Montgomery(u32 n) : n(n), nr(1) {
        rep(i, 0, 5) nr *= 2 - n * nr;
    }

    [[nodiscard]] u32 reduce(uint64_t x) const {
        u32 q = u32(x) * nr;
        u32 m = ((uint64_t) q * n) >> 32;
        u32 r = (x >> 32) + n - m;
        return r <= n ? x : x - n;
    }

    [[nodiscard]] u32 multiply(u32 x, u32 y) const {
        return reduce((uint64_t) x * y);
    }
};

constexpr Montgomery MOD((u32) 1e9 + 7);

struct Mod {
    u32 x;

    explicit Mod(u32 x = 0) : x(MOD.reduce(x)) {}

    Mod operator+(Mod b) const { return Mod(b.x + x); }

    Mod operator*(Mod b) const {
        return Mod(MOD.multiply(x, b.x));
    }
};

Mod dbg(Mod x) {
    cerr << x.x << '\n';
    return x;
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);
    cout << fixed << setprecision(15);

    int H, W;
    cin >> H >> W;

    vector<vector<Mod>> ans(H + 1, vector<Mod>(W + 1, Mod(0)));
    vector<vector<Mod>> cnt(H + 1, vector<Mod>(W + 1, Mod(0)));
    rep(h, 1, H + 1) {
        rep(w, 1, W + 1) {
            ans[h][w] = Mod(h) * Mod(w);
            cnt[h][w] = Mod(1);
            rep(h1, 1, h - 1) {
                rep(w1, 1, w - 1) {
                    Mod cnt_pos = Mod(w - 1 - w1) * Mod(h - 1 - h1);

                    Mod tmp = cnt_pos * (Mod(w) * Mod(h) * cnt[h1][w1] + ans[h1][w1]);
                    ans[h][w] = ans[h][w] + tmp;
                    cnt[h][w] = cnt[h][w] + cnt_pos * cnt[h1][w1];
                }
            }
        }
    }

    cout << ans[H][W].x << '\n';
}
