#include <bits/stdc++.h>
using namespace std;

const double eps = 1e-10;

#define int long long

const int N = 100010;

int x[N];
int p[N];

struct SegTree{
    static const int n = 100010;
    int t[4 * n];
    int add[4 * n];
    SegTree() {
        fill(t, t + 4 * n, 0);
        fill(add, add + 4 * n, 0);
    }
    void push(int l, int r, int ind) {
        if (l != r) {
            add[2 * ind + 1] += add[ind];
            add[2 * ind + 2] += add[ind];
        }
        t[ind] += add[ind];
        add[ind] = 0;
    }
    void addseg(int l, int r, int val, int ln, int rn, int ind) {
        push(ln, rn, ind);
        if (l <= ln && rn <= r) {
            add[ind] += val;
            push(ln, rn, ind);
            return;
        }
        if (ln > r || rn < l) return;
        int mn = (ln + rn) / 2;
        addseg(l, r, val, ln, mn, 2 * ind + 1);
        addseg(l, r, val, mn + 1, rn, 2 * ind + 2);
        t[ind] = max(t[2 * ind + 1], t[2 * ind + 2]);
    }
    void addseg(int l, int r, int val) {
        addseg(l, r, val, 0, n - 1, 0);
    }


    int maxseg(int l, int r, int ln, int rn, int ind) {
        push(ln, rn, ind);
        if (l <= ln && rn <= r) {
            return t[ind];
        }
        if (ln > r || rn < l) return 0;
        int mn = (ln + rn) / 2;
        return max(maxseg(l, r, ln, mn, 2 * ind + 1), maxseg(l, r, mn + 1, rn, 2 * ind + 2));
    }
    int maxseg(int l, int r) {
        return maxseg(l, r, 0, n - 1, 0);
    }

} ST;

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, B, C;
    cin >> n >> B >> C;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> p[i];
    }
    x[n++] = 3e9;
    int i = 0;
    set<pair<int, int>> se;
    while (true) {
        se.insert({p[i], i});
        int dist = x[i + 1] - x[i];
        while (dist) {
            if (se.empty()) {
                cout << x[i + 1] - dist;
                return 0;
            }
            auto nw = *se.begin();
            int mx = ST.maxseg(nw.second, i);
            if (mx == C) {
                se.erase(se.begin());
                continue;
            }
            int plus = min({dist, C - mx, B / nw.first});
            if (!plus) {
                cout << x[i + 1] - dist;
                return 0;
            }
            ST.addseg(nw.second, i, plus);
            dist -= plus;
            B -= plus * nw.first;
        }
        ++i;
    }
    return 0;
}


/*
3 10 5
0 3
 1 1
4 2
 */