#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

ld eps = 1e-7;

ostream& operator << (ostream& out, vector<int>& vec) {
    for (int el :vec) {
        out << el << ' ';
    }
    return out;
}

ostream& operator << (ostream& out, vector<bool>& vec) {
    for (bool el :vec) {
        if (el)
            out << '#';
        else
            out << '.';
    }
    return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& vec) {
    for (T el :vec) {
        out << el << '\n';
    }
    return out;
}


const int N = 1e5 + 10;
const int LOG_N = 20;
pair<int, int> sparse[LOG_N][N];
int lg2[N];

void build_table(vector<int>& a) {
    for (int i = 0; i < a.size(); ++i) {
        sparse[0][i] = make_pair(a[i], i);
    }
    lg2[0] = 0;
    lg2[1] = 0;
    for (int i = 2; i < N; ++i) {
        lg2[i] = lg2[i / 2] + 1;
    }
    for (int k = 1; k < LOG_N; ++k) {
        for (int i = 0; i + (1 << (k - 1)) < a.size(); ++i) {
            sparse[k][i] = min(sparse[k - 1][i], sparse[k - 1][i + (1 << (k - 1))]);
        }
    }
}

int get_min(int l, int r) {
    if (l < 0)
        l = 0;
    int lg = lg2[r - l + 1];
    return min(sparse[lg][l], sparse[lg][r - (1 << lg) + 1]).second;
}

bool check(int m, vector<int>& x, vector<int>& cost, int b, int c) {
    while (m > 0) {
        int l = lower_bound(x.begin(), x.end(), m - c) - x.begin();
        if (l == x.size())
            return false;
        int r = upper_bound(x.begin(), x.end(), m) - x.begin() - 1;
        //cout << m << ' ' << l << ' ' << r << '\n';
        int mn = get_min(l, r);
        int x1 = x[l];
        if ((m - x1) * (ll) mn > b)
            return false;
        b -= (m - x1) * mn;
        m = x1;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    //freopen("input.txt", "r", stdin);
    int n, b, c;
    cin >> n >> b >> c;
    vector<int> x(n), cost(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> cost[i];
    }
    build_table(cost);
    /*
    for (int k = 0; k < 3; ++k) {
        for (int i = 0; i < n; ++i) {
            cout << sparse[k][i].first << ' ';
        }
        cout << '\n';
    }
    cout << endl;
     */
    int left = 0, right = 2e9 + 2;
    while (right - left > 1) {
        int mid = (left + (ll) right) / 2;
        //cout << left << ' ' << mid << ' ' << right << endl;
        if (check(mid, x, cost, b, c))
            left = mid;
        else
            right = mid;
    }
    cout << left;
}
