#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pi pair<int, int>

const long long inf = LLONG_MAX / 2;
const long long mod = 1e9 + 7;

vector<long long> dijk(vector<vector<pi>> &g, vector<int> &cnt, int v) {
    cnt[v] = 1;
    set<pair<long, long> > st;
    vector<long long> dist(g.size(), inf);
    dist[v] = 0;
    st.insert({dist[v], v});
    while (!st.empty()) {
        int u = st.begin()->second;
        st.erase(st.begin());
        for (auto to: g[u]) {
            if (dist[to.first] > dist[u] + to.second) {
                st.erase({dist[to.first], to.first});
                dist[to.first] = dist[u] + to.second;
                st.insert({dist[to.first], to.first});
            }
        }
        for (auto to: g[u]) {
            if (dist[to.first] + to.second == dist[u]) {
                cnt[u] = (cnt[to.first] + cnt[u]) % mod;
            }
        }
    }
    return dist;
}

void bfs(int v, vector<vector<pi>> &g, vector<bool> &path, vector<long long> &dist) {
    path[v] = 1;
    queue<int> q;
    q.push(v);
    while (!q.empty()) {
        int u = q.front();
//        cout << "current u = " << u << endl;
        q.pop();
        for (auto to: g[u]) {
            if (dist[to.first] + to.second == dist[u]) {
                q.push(to.first);
                path[to.first] = 1;
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int start, finish, L;
    cin >> start >> finish >> L;
    --start;
    --finish;
    vector<vector<pi>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        --a;
        --b;
        g[a].push_back({b, w});
        g[b].push_back({a, w});
    }
    vector<bool> in_path(n, false);
    vector<int> cnt_start(n, 0), cnt_finish(n, 0);
    vector<int> dist_start = dijk(g, cnt_start, start);
    vector<int> dist_finish = dijk(g, cnt_finish, finish);
    bfs(finish, g, in_path, dist_start);
//    for (auto x : dist_start) cout << x << " ";
//    cout << endl;
//    for (auto x: cnt_start) cout << x << " ";
//    cout << endl;
//    for (auto x : in_path) cout << x << " ";
//    cout << endl;
    long long ans = (dist_start[finish] == L ? cnt_start[finish] : 0);
    if (ans) {
        cout << ans << "\n";
        return 0;
    }
    for (int v = 0; v < n; v++)
        if (in_path[v] && v != finish) {
            long long add = 0;
            for (auto to: g[v]) {
                if (dist_start[v] + to.second + dist_finish[to.first] == L) {
                    add = ((long long)add + (long long)cnt_start[v] * (long long)cnt_finish[to.first]) % mod;
                }
            }
            ans = (ans + add) % mod;
        }
    cout << ans << "\n";
}
