#ifdef LOCAL
//#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<pll> vpll;
typedef long double ld;

const ll INF = 1e18;
const ll mod = 1e9 + 7;
const ll LIMIT = 1e9 * 2;

void dfs(int i, int j, int n, int m, vector<string> &s) {
    //cout << i << ' ' << j << endl;
    if (i >= n || i < 0 || j >= m || j < 0 || s[i][j] != '.') {
        return;
    }
    s[i][j] = '*';
    dfs(i + 1, j, n, m, s);
    dfs(i - 1, j, n, m, s);
    dfs(i, j + 1, n, m, s);
    dfs(i, j - 1, n, m, s);
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll h, w;
    cin >> h>>w;
    vector<string> vs(h);
    for(int i=0;i<h;i++)
    {
        cin>>vs[i];
    }

    vector<vector<int>> used(h, vector<int> (w, 0));
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            //cout << "smifnoignond" << endl;
            if (!used[i][j] && (i == h - 1 || j == w - 1 || i == 0 || j == 0) && vs[i][j] == '.') {
                dfs(i, j, h, w, vs);
            }
        }
    }
    vector<bool> a(max(h, w), 0);
    for (int i = 1; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            if (vs[i][j] == '.') {
                if (a[j]) {
                    int hlp_i = i - 1;
                    while (hlp_i >= 0 && vs[hlp_i][j] == '#') {
                        vs[hlp_i][j] = '.';
                        hlp_i--;
                    }
                }
                a[j] = 1;
            }
        }
    }
    a.assign(max(h, w), 0);
    for (int j = 1; j < w; ++j) {
        for (int i = 0; i < h; ++i) {
            if (vs[i][j] == '.') {
                if (a[i]) {
                    int hlp_j = j - 1;
                    while (hlp_j >= 0 && vs[i][hlp_j] == '#') {
                        vs[i][hlp_j] = '.';
                        hlp_j--;
                    }
                }
                a[i] = 1;
            }
        }
    }
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            //cout << i << ' ' << j << endl;
            bool t = (i + 1 < h && j + 1 < w && vs[i + 1][j + 1] == '.');
            t |= (j + 1 < w && vs[i][j + 1] == '.');
            t |= (i - 1 >= 0 && j + 1 < w && vs[i - 1][j + 1] == '.');
            t |= (i + 1 < h && j - 1 >= 0 && vs[i + 1][j - 1] == '.');
            t |= (j - 1 >= 0 && vs[i][j - 1] == '.');
            t |= (i - 1 >= 0 && j - 1 >= 0 && vs[i - 1][j - 1] == '.');
            t |= (i - 1 >= 0 && vs[i - 1][j] == '.');
            t |= (i + 1 < h && vs[i + 1][j] == '.');
            if (t && vs[i][j] == '#') {
                cout << "#";
            } else {
                cout << ".";
            }
        }
        cout << '\n';
    }
    return 0;
}
/*
6 6
######
#....#
#.#.##
#.#..#
######
######

 * */