#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <math.h>
#include <map>
#include <set>
#include <string>
#define int long long
using namespace std;

const int INF = 1e18;
const int MOD = 1e9 + 7;

vector<vector<pair<int, int>>> g;
vector<pair<int, int>> path;
vector<pair<int, int>> rpath;
vector<vector<int>> pred;
vector<bool> included;
int n, m;

void dijkstra(int s, int t) {
	set<pair<int, int>> pq;
	pq.insert({ 0, t });
	path[t] = { 0, 1 };
	vector<bool> vis(n, false);
	vis[t] = true;
	while (!pq.empty()) {
		auto [uw, u] = *pq.begin();
		pq.erase(pq.begin());
		for (auto [v, w] : g[u]) {
			if (vis[v])
				continue;
			if (path[v].first > uw + w) {
				pq.erase({ path[v].first, v });
				path[v] = { uw + w, path[u].second };
				pq.insert({ path[v].first, v });
			} else if (path[v].first == uw + w) {
				path[v].second = (path[v].second + path[u].second) % MOD;
			}
		}
	}
	pq.clear();
	pq.insert({ 0, s });
	rpath[s] = { 0, 1 };
	vis.assign(n, false);
	vis[s] = true;
	while (!pq.empty()) {
		auto [uw, u] = *pq.begin();
		pq.erase(pq.begin());
		for (auto [v, w] : g[u]) {
			if (vis[v])
				continue;
			if (rpath[v].first > uw + w) {
				pq.erase({ rpath[v].first, v });
				rpath[v] = { uw + w, rpath[u].second };
				pq.insert({ rpath[v].first, v });
			} else if (rpath[v].first == uw + w) {
				rpath[v].second = (rpath[v].second + rpath[u].second) % MOD;
			}
		}
	}
}

signed main() {
	int s, t, l;
	cin >> n >> m >> s >> t >> l;
	s--, t--;

	g.resize(n);
	path.assign(n, { INF, 0 });
	rpath.assign(n, { INF, 0 });

	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		u--, v--;
		g[u].push_back({ v, w });
		g[v].push_back({ u, w });
	}

	dijkstra(s, t);

	if (l == path[s].first) {
		cout << path[s].second;
		return 0;
	}

	included.assign(n, false);
	included[s] = true;
	for (int u = 0; u < n; ++u) {
		if (u == s || u == t)
			continue;
		if (path[u].first + rpath[u].first == path[s].first)
			included[u] = true;
	}

	int ans = 0;
	for (int u = 0; u < n; ++u) {
		if (!included[u])
			continue;
		for (auto [v, w] : g[u]) {
			//if (rpath[u].first + w + path[v].first == path[s].first)
			//	continue;
			if (rpath[u].first + w + path[v].first != l)
				continue;
			ans = (ans + rpath[u].second * path[v].second) % MOD;
		}
	}
	cout << ans << "\n";
}