#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <math.h>
#include <map>
#include <set>
#define int long long
using namespace std;

const int INF = 1e18;

vector<int> a;
vector<int> tree;
vector<int> lazy;
void push(int i, int l, int r) {
	tree[i] += lazy[i];
	if (r - l != 1) {
		lazy[2 * i + 1] += lazy[i];
		lazy[2 * i + 2] += lazy[i];
	}
	lazy[i] = 0;
}

void add(int i, int l, int r, int ql, int qr, int qx) {
	push(i, l, r);
	if (qr <= l || r <= ql)
		return;
	if (ql <= l && r <= qr) {
		lazy[i] += qx;
		push(i, l, r);
		return;
	}
	int mid = (l + r) / 2;
	add(i * 2 + 1, l, mid, ql, qr, qx);
	add(i * 2 + 2, mid, r, ql, qr, qx);
	tree[i] = max(tree[i * 2 + 1], tree[i * 2 + 2]);
}

int get(int i, int l, int r, int ql, int qr) {
	push(i, l, r);
	if (qr <= l || r <= ql)
		return 0;
	if (ql <= l && r <= qr)
		return tree[i];
	
	int mid = (l + r) / 2;
	return max(get(i * 2 + 1, l, mid, ql, qr), get(i * 2 + 2, mid, r, ql, qr));
}

signed main() {
	int n, b, c;
	cin >> n >> b >> c;
	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i].first >> a[i].second;

	tree.resize(4 * n, 0);
	lazy.resize(4 * n, 0);
	a.push_back({ INF, INF });

	set<pair<int, int>> pq;
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		auto [x, p] = a[i];
		pq.insert({ p, i });
		int needed = min(c, a[i + 1].first - a[i].first);
		int delta = 0;
		while (!pq.empty() && delta < needed) {
			auto [pp, j] = *pq.begin();
			int dd = c - get(0, 0, n, j, i + 1);
			int dreal = min(b / pp, dd);
			if (dreal == 0) {
				pq.erase(pq.begin());
				continue;
			}
			if (dreal <= needed - delta) {
				pq.erase(pq.begin());
				add(0, 0, n, j, i + 1, dreal);
				delta += dreal;
				b -= dreal * pp;
			} else {
				dreal = needed - delta;
				add(0, 0, n, j, i + 1, dreal);
				delta += dreal;
				b -= dreal * pp;
			}
		}
		ans = max(ans, x + delta);
		if (x + delta < a[i + 1].first)
			break;
	}
	cout << ans << "\n";
}