#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <random>

using namespace std;

#ifdef KROL
#define dbg(x) cerr << #x << ":\n " << x << "\n";
#else
#define dbg(x);
#endif

typedef long long ll;
typedef long double ld;

#define int ll
#define sz(x) int(x.size())

const int maxn = 500;

ll dp[maxn][maxn];
ll dp_pref[maxn][maxn];
ll dp_pref_h[maxn][maxn];

ll cnt[maxn][maxn];
ll cnt_pref[maxn][maxn];
ll cnt_pref_h[maxn][maxn];

const int mod = 1e9 + 7;

ll add(ll a, ll b) {
	int res = (a + b) % mod;
	if (res < 0) res = (res + mod) % mod;
	return res;
}

ll mul(ll a, ll b) {
	return (a * b) % mod;
}

void solve() {
	int W, H;
	cin >> W >> H;
	for (int w = 1; w <= W; w++) {
		for (int h = 1; h <= H; h++) {
			dp[w][h] = mul(w, h);
			cnt[w][h] = 1;
			for (int w1 = 1; w1 <= w - 2; w1++) {
				{
					int f = mul(h - 1, dp_pref[w1][h - 2]);
					f = add(f, -dp_pref_h[w1][h - 2]);
					int s = add(mul(h - 1, cnt_pref[w1][h - 2]), -cnt_pref_h[w1][h - 2]);
					s = mul(s, mul(w, h));
					int kok = add(f, s);
					kok = mul(kok, w - w1 - 1);
					dp[w][h] = add(dp[w][h], kok);
				}
				{
					int f = mul(h - 1, cnt_pref[w1][h - 2]);
					f = add(f, -cnt_pref_h[w1][h - 2]);
					f = mul(f, w - w1 - 1);
					cnt[w][h] = add(cnt[w][h], f);
				}
			}
			dp_pref[w][h] = add(dp_pref[w][h - 1], dp[w][h]);
			dp_pref_h[w][h] = add(dp_pref_h[w][h - 1], mul(dp[w][h], h));
			
			cnt_pref[w][h] = add(cnt_pref[w][h - 1], cnt[w][h]);
			cnt_pref_h[w][h] = add(cnt_pref_h[w][h - 1], mul(cnt[w][h], h));
		}
	}
	cout << dp[W][H] << '\n';
}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);
	cout << fixed << setprecision(20);

	int T = 1;
	//cin >> T;

	for (int t = 1; t <= T; ++t) {
		solve();
	}
}