#include <bits/stdc++.h>
#define int long long
#define ld long double
#define vc vector
#define F first
#define S second
#define pb push_back
#define debug(x) cerr<<(#x)<<": "<<x<<endl;
#define pii pair <int, int>
using namespace std;
const int mod = 1e9 + 7;
int add(int a, int b) {
    if ((a + b) >= mod) {
        return a + b - mod;
    }
    return a + b;
}
int mul(int a, int b) {
    return (a * b) % mod;
}
const int N = 1010;
int n, m;
bool field[N][N];
int dx[8] = {1, 0, -1, 0, 1, 1, -1, -1};
int dy[8] = {0, 1, 0, -1, 1, -1, 1, -1};
bool check (int x, int y) {
    return x >= 0 && y >= 0 && x < n && y < m;
}
bool bad (int i, int j) {
    int cnt = 0;
    for (int k = 0; k < 4; ++k) {
        int x = i + dx[k], y = j + dy[k];
        if (check(x, y)) {
            cnt += field[x][y];
        }
    }
    return cnt <= 1;
}

int mark[N][N], used[N][N];

void dfs (int i, int j) {
    if (used[i][j]) return;
    used[i][j] = 1;
    for (int k = 0; k < 8; ++k) {
        int x = i + dx[k], y  = j + dy[k];
        if (!check(x, y)) continue;
        if (field[x][y]) mark[x][y] = 1;
        else dfs(x, y);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            if (c == '#') {
                field[i][j] = 1;
            } else {
                field[i][j] = 0;
            }
        }
    }
    vector<vector<bool>> us(n, vector<bool>(m));
    {
        vector<pair<int, int>> zxc;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (i == 0 || j == 0 || i == n - 1|| j == m - 1) {
                    if (field[i][j] == 0) zxc.push_back({i, j});
                }
            }
        }
        for (auto start : zxc) {
            if (us[start.first][start.second]) continue;
            queue<pair<int, int>> q;
            q.push(start);
            us[start.first][start.second] = true;
            while (!q.empty()) {
                int x = q.front().first, y = q.front().second;
                q.pop();
                if (x != 0 && !us[x - 1][y] && field[x - 1][y] == 0) {
                    us[x - 1][y] = true;
                    q.push({x - 1, y});
                }
                if (x != n - 1 && !us[x + 1][y] && field[x + 1][y] == 0) {
                    us[x + 1][y] = true;
                    q.push({x + 1, y});
                }
                if (y != 0 && !us[x][y - 1] && field[x][y - 1] == 0) {
                    us[x][y - 1] = true;
                    q.push({x, y - 1});
                }
                if (y != m - 1 && !us[x][y + 1] && field[x][y + 1] == 0) {
                    us[x][y + 1] = true;
                    q.push({x, y + 1});
                }
            }
        }
    }
    queue <pii> q;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (bad(i, j))
                q.push({i, j});
        }
    }
    while (!q.empty()) {
        auto [i, j] = q.front(); q.pop();
        if (!field[i][j]) continue;
        field[i][j] = 0;
        for (int k = 0; k < 4; ++k) {
            int x = i + dx[k], y = j + dy[k];
            if (check(x, y) && bad(x, y))
                q.push({x, y});
        }
    }
    for (int i = 1; i < n - 1; ++i) {
        for (int j = 1; j < m - 1; ++j) {
            if (!us[i][j] && !field[i][j])
                dfs(i, j);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << (field[i][j] && mark[i][j] ? '#' : '.');
        }
        cout << '\n';
    }
}
/*
 * 4 4
####
#..#
#.##
###.
 */