#include <bits/stdc++.h>
#define int long long
#define ld long double
#define pb push_back
#define debug(x) cerr<<(#x)<<": "<<x<<endl;
using namespace std;
const int mod = 1e9 + 7;
int add(int a, int b) {
    if ((a + b) >= mod) {
        return a + b - mod;
    }
    return a + b;
}
int mul(int a, int b) {
    return (a * b) % mod;
}
int sub(int a, int b) {
    if (a - b < 0) return a - b + mod;
    return a - b;
}
struct Fenwick {
    vector<int> tree;
    int n;
    Fenwick(int _n) : tree(_n + 1), n(_n) {}
    void update(int i, int val) {
        for (++i; i <= n; i += i & -i)
            tree[i] = add(tree[i], val);
    }
    int get(int r) {
        int ans = 0;
        for (++r; r > 0; r -= r & -r) ans = add(ans, tree[r]);
        return ans;
    }
    int get(int l, int r) {
        return sub(get(r), get(l - 1));
    }
};
struct SegTree{
    vector<int> tree;
    int n;
    SegTree(int _n) : n(_n), tree(2 * _n, -1) {}
    void update(int pos, int val) {
        pos += n;
        tree[pos] = max(tree[pos], val);
        for (; pos > 1; pos >>= 1) tree[pos >> 1] = max(tree[pos], tree[pos ^ 1]);
    }
    int get(int l, int r) {
        int s = -1;
        for (l += n, r += n + 1; l < r; l >>= 1, r >>= 1) {
            if (l & 1) s = max(s, tree[l++]);
            if (r & 1) s = max(s, tree[--r]);
        }
        return s;
    }
};
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> a;
    vector<int> all;
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        a.push_back({l, r, i});
        all.push_back(l), all.push_back(r);
    }
    sort(all.begin(), all.end());
    all.erase(unique(all.begin(), all.end()), all.end());
    for (int i = 0; i < n; i++) {
        a[i][0] = lower_bound(all.begin(), all.end(), a[i][0]) - all.begin();
        a[i][1] = lower_bound(all.begin(), all.end(), a[i][1]) - all.begin();
    }

    vector<int> ans(n);
    sort(a.begin(), a.end(), [](vector<int> left, vector<int> right){
        if (left[0] == right[0]) return left[1] > right[1];
        return left[0] < right[0];
    });
    vector<int> h(n);
    SegTree st(3 * n);
    vector<vector<int>> z(n);
    for (int i = 0; i < n; i++) {
        int l = a[i][0], r = a[i][1], ind = a[i][2];
        h[ind] = st.get(r, 3 * n - 1) + 1;
        st.update(r, h[ind]);
    }
    int maxh = *max_element(h.begin(), h.end());
    for (int i = 0; i < n; ++i) {
        int ind = a[i][2];
        h[ind] = maxh - h[ind];
        z[h[ind]].pb(i);
    }
    Fenwick t(n * 3);
    vector<int> dp(n);
    for (int i : z[0]) dp[a[i][2]] = 1;
    for (int i = 0; i < maxh; ++i) {
        vector<vector<int>> ev;
        for (int j : z[i]) {
            ev.push_back(a[j]);
        }
        for (int j : z[i + 1]) {
            ev.push_back(a[j]);
        }
        sort(ev.begin(), ev.end(), [](vector<int> left, vector<int> right){
            if (left[1] == right[1]) return left[0] < right[0];
            return left[1] < right[1];
        });
        for (auto x : ev) {
            int j = x[2];
            if (h[j] == i) {
                t.update(x[0], dp[j]);
            } else {
                dp[j] = add(t.get(x[0], x[1]), 1);
            }
        }
        for (int j : z[i]) {
            t.update(a[j][0], sub(0, dp[a[j][2]]));
        }
    }
    for (int i = 0; i < n; ++i) cerr << h[i] << ' ';
    cerr << '\n';
    for (int i = 0; i < n; i++) cout << dp[i] << " ";
}
