#include <bits/stdc++.h>
#define int long long
#define ld long double
#define pb push_back
#define debug(x) cerr<<(#x)<<": "<<x<<endl;
using namespace std;
const int mod = 1e9 + 7;
int add(int a, int b) {
    if ((a + b) >= mod) {
        return a + b - mod;
    }
    return a + b;
}
int mul(int a, int b) {
    return (a * b) % mod;
}
int sub(int a, int b) {
    if (a - b < 0) return a - b + mod;
    return a - b;
}
struct Fenwick {
    vector<int> tree;
    int n;
    Fenwick(int _n) : tree(_n + 1), n(_n) {}
    void update(int i, int val) {
        for (++i; i <= n; i += i & -i)
            tree[i] = add(tree[i], val);
    }
    int get(int r) {
        int ans = 0;
        for (++r; r > 0; r -= r & -r) ans = add(ans, tree[r]);
        return ans;
    }
    int get(int l, int r) {
        return sub(get(r), get(l - 1));
    }
};
struct SegTree{
    vector<int> tree;
    int n;
    SegTree(int _n) : n(_n), tree(2 * _n, -1) {}
    void update(int pos, int val) {
        pos += n;
        tree[pos] = max(tree[pos], val);
        for (; pos > 1; pos >>= 1) tree[pos >> 1] = max(tree[pos], tree[pos ^ 1]);
    }
    int get(int l, int r) {
        int s = -1;
        for (l += n, r += n + 1; l < r; l >>= 1, r >>= 1) {
            if (l & 1) s = max(s, tree[l++]);
            if (r & 1) s = max(s, tree[--r]);
        }
        return s;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> who(n);
    vector<int> ans(n);
    int c = 0;
    int i = 0;
    vector<int> color(n);
    while (i < n) {
        if (i == n - 1) {
            color[i] = c++;
            break;
        } else {
            color[i] = color[i + 1] = c++;
            i += 2;
        }
    }
    cout << c << endl;
    for (i = 0; i < n; i++) cout << color[i] + 1 << " ";
    cout << endl;
    for (i = 0; i < c; i++) {
        int sz;
        cin >> sz;
        if (sz == 1) {
            int x;
            cin >> x;
            ans[n - 1] = x - 1;
        } else {
            int x, y;
            cin >> x >> y;
            x--, y--;
            who[x].push_back(y);
            who[y].push_back(x);
        }
    }
    c = 0;
    int cn = n;
    if (n % 2 != 0) n--;
    for (i = 1; i + 1 < n; i += 2) {
        color[i] = color[i + 1] = c++;
    }
    if (cn & 1) color[cn - 1] = c++;
    // 0 ... n - 1
    color[0] = c++;
    color[n - 1] = c++;
    cout << c << endl;
    for (i = 0; i < cn; i++) cout << color[i] + 1 << " ";
    cout << endl;
    for (i = 0; i < c; i++) {
        int sz;
        cin >> sz;
        if (sz == 1) {
            int x;
            cin >> x;
        } else {
            int x, y;
            cin >> x >> y;
            x--, y--;
            who[x].push_back(y);
            who[y].push_back(x);
        }
    }
    //....
    c = 0;
    color[0] = c++;
    for (i = 1; i < cn; i++) color[i] = c;
    c++;
    cout << c << endl;
    for (i = 0; i < cn; i++) cout << color[i] + 1 << " ";
    cout << endl;
    for (i = 0; i < c; i++) {
        int sz;
        cin >> sz;
        if (sz == 1) {
            int x;
            cin >> x;
            x--;
            // x is first
            ans[0] = x;
            int prv = -1, nxt = 1;
            while (nxt != cn) {
                for (int j : who[x]) {
                     if (j == prv) continue;
                     ans[nxt] = j;
                     prv = x;
                     x = j;
                     break;
                }
                nxt++;
            }
        } else {
            int x;
            for (int j = 0; j < sz; j++) cin >> x;
        }
    }
    for (i = 0; i < cn; i++) cout << ans[i] + 1 << " ";
    cout << endl;
}
