#pragma GCC optimize("Ofast")
#include <string>
#include <vector>
#include <iomanip>
#include <iostream>
#include <numeric>
#include <cmath>
#include <set>
#include <map>

using namespace std;
typedef long long ll;
typedef long double ld;

#define MOD ll(1e9+7)
#define INF ll(1e18)
#define SIZE 200000

#define pb push_back
#define ppb pop_back
#define f first
#define s second

#define all(x) x.begin(), x.end()
#define vout(x) for (auto u : x) cout << u << ' ';
#define rndm drist(rng)

#define loop(i, n) for (ll i = 0; i < n; i ++)
#define loopbone(i, n) for (ll i = 1; i <= n; i++)
#define loopb(i, n) for (ll i = n-1; i >= 0; i--)
#define loopbone(i, n) for (ll i = n; i > 0; i--)

//mt19937_64 rng(time(0));
//uniform_int_distribution<ll> dist;

vector<int> X, Y, wh;

int nowx = 0, nowy = 0;

void go_down() {
	++nowx;
	X.push_back(nowx);
	Y.push_back(nowy);
	wh.push_back(2);
}

void go_up() {
	--nowx;
	X.push_back(nowx);
	Y.push_back(nowy);
	wh.push_back(0);
}

void go_right() {
	++nowy;
	X.push_back(nowx);
	Y.push_back(nowy);
	wh.push_back(1);
}

void go_left() {
	--nowy;
	X.push_back(nowx);
	Y.push_back(nowy);
	wh.push_back(3);
}

void buildm(int n, int m) {
	for (int i = 0; i < m; ++i) {
		if (i % 2) {
			while (nowx > 1) {
				go_up();
			}
		} else {
			while (nowx + 1 < n) {
				go_down();
			}
		}
		if (i + 1 != m) {
			go_right();
		}
	}
	go_up();
	while (nowy > 0) {
		go_left();
	}
}

void buildn(int n, int m) {
	for (int i = 0; i < n; ++i) {
		if (i % 2) {
			while (nowy > 1) {
				go_left();
			}
		} else {
			while (nowy + 1 < m) {
				go_right();
			}
		}
		if (i + 1 != n) {
			go_down();
		}
	}
	go_left();
	while (nowx > 0) {
		go_up();
	}
}

void build1(int n, int m) {
	for (int i = 0; i + 2 < m; ++i) {
		if (i % 2) {
			while (nowx > 1) {
				go_up();
			}
		} else {
			while (nowx + 1 < n) {
				go_down();
			}
		}
		go_right();
	}
	go_up();
	for (int i = n - 2; i > 0; --i) {
		if (i % 2) {
			go_right();
		} else {
			go_left();
		}
		go_up();
	}
	while (nowy > 0) {
		go_left();
	}
}

void build2(int n, int m) {
	for (int i = 0; i + 2 < m; ++i) {
		if (i % 2) {
			while (nowx > 1) {
				go_up();
			}
		} else {
			while (nowx + 1 < n) {
				go_down();
			}
		}
		go_right();
	}
	for (int i = n - 1; i > 0; --i) {
		if (i % 2) {
			go_left();
		} else {
			go_right();
		}
		go_up();
	}
	while (nowy > 0) {
		go_left();
	}
}

void build3(int n, int m) {
	for (int i = 0; i + 2 < n; ++i) {
		if (i % 2) {
			while (nowy > 1) {
				go_left();
			}
		} else {
			while (nowy + 1 < m) {
				go_right();
			}
		}
		go_down();
	}
	for (int i = m - 1; i > 0; --i) {
		if (i % 2) {
			go_up();
		} else {
			go_down();
		}
		go_left();
	}
	while (nowx > 0) {
		go_up();
	}
}

void buildnm(int n, int m, int ar, int ac, int br, int bc) {
	if (ar != n - 1 && ac != m - 1 && br != n - 1 && bc != m - 1) {
		build1(n, m);
	} else if (ar != 0 && ac != m - 1 && br != 0 && bc != m - 1) {
		build2(n, m);
	} else {
		build3(n, m);
	}
}

void build_path(int n, int m, int ar, int ac, int br, int bc) {
	if (m % 2 == 0) {
		buildm(n, m);
	} else if (n % 2 == 0) {
		buildn(n, m);
	} else {
		buildnm(n, m, ar, ac, br, bc);
	}
}

ll tabl[5000][5000];
char CH[4] = {'U', 'R', 'D', 'L'};
char CH_obr[4] = { 'D', 'L', 'U', 'R' };

void solve() {
	X.clear();
	Y.clear();
	wh.clear();
	int n, m, ar, ac, br, bc;
	cin >> n >> m >> ar >> ac >> br >> bc;
	--ar; --ac; --br; --bc;
	build_path(n, m, ar, ac, br, bc);
	ll w = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> tabl[i][j];
			w += tabl[i][j];
		}
	}
	int A = -1, B = -1;
	for (int i = 0; i < (int)X.size(); ++i) {
		if (X[i] == ar && Y[i] == ac) {
			A = i;
		} else if (X[i] == br && Y[i] == bc) {
			B = i;
		}
	}
	int i = A;
	ll wnw = 0;
	while (true) {
		wnw += tabl[X[i]][Y[i]];
		if (i == B) {
			break;
		}
		i = (i + 1) % (int)X.size();
	}
	if (wnw * 2 > w) {
		i = A;
		while (true) {
			if (i == B) {
				break;
			}
			cout << CH[wh[(i + 1) % (int)X.size()]];
			i = (i + 1) % (int)X.size();
		}
		cout << '\n';
		return;
	}
	i = A;
	while (true) {
		if (i == B) {
			break;
		}
		cout << CH_obr[wh[i]];
		i = (i + (int)X.size() - 1) % (int)X.size();
	}
	cout << '\n';
	return;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); 
	int t; cin >> t;
	while (t--) {
		solve();
	}
}
